<?php
/* Das ist das Verowa Admin Interface, wo festgelegt werden kann, welche Kriterien im Agenda Filter
 * angezeigt werden.
 */
 
function load_sortable_for_this_page( $hook ) {
	wp_enqueue_script( 'jquery-ui-sortable' );
}

add_action( 'admin_enqueue_scripts', 'load_sortable_for_this_page' );

function verowa_dropdown_configuration_page() {
	$how_many_verowa_dropdowns_before = get_option( 'how_many_verowa_dropdowns', false );

	// Abfangen, falls etwas schief läuft, und initial auf 3 setzen
	if ( $how_many_verowa_dropdowns_before == false ) {
		$how_many_verowa_dropdowns_before = 3;
		$how_many_verowa_dropdowns = 3;
		update_option( 'how_many_verowa_dropdowns', '3', true );
	}

	if ( isset( $_POST['verowa_wp_listengruppen_id'] ) ) {
		update_option( 'verowa_wordpress_listengruppe', $_POST['verowa_wp_listengruppen_id'], true);
	}
	
	$int_anzahl_zaehler = 1;
	
	// Setzt die Optionen als Array in der WP Datenbank zusammen von allen durch den Kunden eingertragenen Menüs
	// wir speichern alle Optionen der vorher vorhandenen Menüs, auch wenn es später weniger sind
	// (Es ist sicherer immer alle Optionen zu behalten, falls etwas fälschlicherweise gelöscht wird)
	while ( isset( $_POST['how_many_verowa_dropdowns'] ) && $int_anzahl_zaehler <= $how_many_verowa_dropdowns_before ) {
		$str_gewaehlte_listen_ids = implode( ", ", $_POST['dropdown_menu_' . $int_anzahl_zaehler] );
		
		update_option( "verowa_dropdown_" . $int_anzahl_zaehler, $str_gewaehlte_listen_ids, true );
		update_option( "verowa_dropdown_" . $int_anzahl_zaehler . "_title", $_POST["dropdown_menu_" .
			$int_anzahl_zaehler . "_title"], true );

		$int_anzahl_zaehler++;
	}

	// die neue Anzahl Menüs speichern
	if (isset( $_POST["how_many_verowa_dropdowns"] ) ) {
		update_option( "how_many_verowa_dropdowns", $_POST["how_many_verowa_dropdowns"], true );
		
		// Cache Update
		$request = new WP_REST_Request( 'GET', '/verowa/v1/update/update' );
		$response = rest_do_request( $request );
	}

	// Angaben nochmals sauber aus der DB holen (zur Sicherheit)
	$how_many_verowa_dropdowns = get_option( 'how_many_verowa_dropdowns', true );
	$wp_verowa_listengruppe = get_option( 'verowa_wordpress_listengruppe', true );

	// Logo holen
	$verowa_image_url = plugins_url( '../images/verowa.png', __FILE__ );

	echo '<div class="wrap">' .
		'<img src="' . $verowa_image_url . '" style="height:56px;float:left;" />' .
		'<h1>' . __( 'Verowa filter options', 'verowa-connect' ) . '</h1>' .
		'<form method="POST"><div class="card">' .
		__( 'Number of dropdown menus', 'verowa-connect' ) . ': ' .
		'<input type="number" name="how_many_verowa_dropdowns" value="' . $how_many_verowa_dropdowns . '" /><br />' .
		__( 'ID of group with WordPress lists', 'verowa-connect' ) . ': ' .
		'<input type="number" name="verowa_wp_listengruppen_id" value="' . $wp_verowa_listengruppe . '" />' .
		'<br /><br />' .
		'<input type="submit" class="button-primary"></div>';
	
	$arr_listen_in_gruppe = verowa_api_call( 'getlistsbygroup', $wp_verowa_listengruppe, true );
	$int_anzahl_zaehler = 1;
	
	while ( $int_anzahl_zaehler <= $how_many_verowa_dropdowns ) {
		echo '<div class="card" style="display:inline-block;">' .
			'<b>' . __( 'Dropdown menu', 'verowa-connect' ) . ' ' . $int_anzahl_zaehler . '</b> <br />' .
			__( 'Title', 'verowa-connect' ) . ': <input type="text" name="dropdown_menu_' . $int_anzahl_zaehler .
			'_title" value="' . get_option( 'verowa_dropdown_' . $int_anzahl_zaehler . '_title', true) . '" />' .
			'<br />';
		echo '<ul class="verowa_agenda_dropdown_sort">';

		$str_inhalt_aktuelle_liste = get_option( 'verowa_dropdown_' . $int_anzahl_zaehler, true );
		$arr_inhalt_aktuelle_listen = array_unique( explode( ", ", $str_inhalt_aktuelle_liste ) );
		
		foreach ( $arr_inhalt_aktuelle_listen as $group_id ) {
			$group_key = array_search( $group_id, array_column( $arr_listen_in_gruppe, 'list_id' ) );

			echo '<li><span class="dashicons dashicons-move"></span><input type="checkbox" name="dropdown_menu_' .
				$int_anzahl_zaehler . '[]" checked=checked value="' .
				$arr_listen_in_gruppe[$group_key]['list_id'] . '" />' .
				$arr_listen_in_gruppe[$group_key]['name'] . ' <small>(' . __( 'ID', 'verowa-connect' ) . ': ' .
				$arr_listen_in_gruppe[$group_key]['list_id'] . ')</small></li>';			
		}
		
		foreach ( $arr_listen_in_gruppe as $arr_einzelne_liste ) {

			// Checkbox setzen, falls Liste im Array vorhanden ist
			if ( !in_array( strval( $arr_einzelne_liste['list_id'] ), $arr_inhalt_aktuelle_listen ) ) {
				echo '<li><span class="dashicons dashicons-move"></span>' .
					'<input type="checkbox" name="dropdown_menu_' . $int_anzahl_zaehler . '[]" ' . 
					' value="' . $arr_einzelne_liste['list_id'] . '" />' . $arr_einzelne_liste['name'] .
					' <small>(' . __( 'ID', 'verowa-connect' ) . ': ' .
					$arr_einzelne_liste['list_id'] . ')</small></li>';
			}
		}

		echo '</li></div>';
		$int_anzahl_zaehler++;
	}

	echo '<script>jQuery( function() {
		jQuery( ".verowa_agenda_dropdown_sort" ).sortable();
		jQuery( ".verowa_agenda_dropdown_sort" ).disableSelection();
		} );
		</script>';
	echo '</form></div>';
}
?>