<?php
/**
 * Generiert das Widget, das für die Anzeige von Veranstaltungsfiltern benötigt wird.
 * Die Logik der Anzeige wird aber in verowa-event-filter.php festgelegt.
 * 
 */
 
function register_verowa_event_filter_widget() {
	register_widget( 'Verowa_Event_Filter' );
}

add_action( 'widgets_init', 'register_verowa_event_filter_widget' );

class Verowa_Event_Filter extends WP_Widget {
	
	public function __construct() {
		parent::__construct( 'verowa_event_filter_widget', // Base ID
			__( 'Verowa: Event filter', 'verowa-connect' ), // Name
			array(
				'description' => __( 'A widget to filter Verowa events.', 'verowa-connect' )
			) // Args
		);
	}

	// outputs the content of the widget
	public function widget( $args, $instance ) {
		global $post;

		if ( has_shortcode( $post->post_content, 'verowa_agenda' ) ) {
			echo do_shortcode( '[verowa_event_filter titel="' . $instance['title'] . '"]' );
		}
	}

	public function form( $instance ) {
		if ( !empty( $instance['title'] ) ) {
			$title = $instance['title'];
		} else {
			$title = __( 'Choose event', 'verowa-connect' );
		}

		echo '<p><label for="' . $this->get_field_id( 'title' ) . '">' . __( 'Title', 'verowa-connect' ) . ':</label> ' .
			'<input class="widefat" id="' . $this->get_field_id( 'title' ) . '" ' .
			'name="' . $this->get_field_name( 'title' ) . '" type="text" value="' .  esc_attr( $title ) . '"></p>';
	}

	public function update( $new_instance, $dummy ) {
		$instance = array();
		$instance['title'] = ( !empty ($new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';

		return $instance;
	}
}
?>