<?php
/**
 * Dieser Shortcode zeigt speziell angegebene Verowa-Listen an
 * NEU: Attribute anzahl= Zahl und seiten-aufteilen=true (oder false) zusatz
 * NEU 2018, der Shortcode kann mit dem Parameter layer_id= (Komma separiert)
 * verwendet werden
 */

// verowa_event_list ist der richtige Shortcode der verwendet werden sollte.
// Die anderen Beiden werden auf ihn umgeleitet und sollten in der Zukunft entfernt werden.
// Momentan zu aufwendig da man alle Seiten durchgehen und anpassen müsste
add_shortcode( 'verowa_event_list', 'verowa_event_list' );
add_shortcode( 'verowa_event_liste', 'verowa_event_liste' );

function verowa_event_list( $atts ) {
	// Wo keine Werte gesetzt sind, werden Defaults verwendet

	// Wenn die Anzahl eingestellt ist und "Seiten aufteilen" auch auf True gesetzt ist,
	// gibt es mehrere Seiten mit der gesetzten Anzahl.

	// Die default Werte
	$default_pro_seite = 10;
	$default_max = $default_pro_seite;
	$max_max = 1000; // maximal erlaubte Anzahl angezeigter Events
	$arr_eventlist_template = [];

	$atts = shortcode_atts(
		array(
			'id' => '',
			'layer_id' => '',
			'target_group' => '',
			'pro-seite' => $default_pro_seite ,
			'title' => '', // With spaces the title is not displayed.
			'max' => $default_max,
			'max_days' => 365,
			'template_id' => 0,
		),
		$atts,
		'verowa_event_list'
	);

	$hierarchical_layer_ids = json_decode( get_option( 'verowa_hierarchical_layers_tree', ''), true);

	// add sub layer ids.
	$atts['layer_id'] = verowa_get_sub_layer_ids($atts['layer_id'], $hierarchical_layer_ids);

	// if no template id is given we get it from the post meta for this page
	if ( intval( $atts['template_id'] ) == 0 ) {
		$atts['template_id'] = intval( get_post_meta( $post->ID, 'verowa_eventlist_template', true ) );

		// if there is no template id in the post meta either we get the default from the options
		if ( $atts['template_id'] == 0 ) {
			$atts['template_id'] = intval( get_option( 'verowa_default_eventlist_template' ) );
		}
	}

	if ( $atts['template_id'] > 0 ) {
		$arr_eventlist_template = verowa_get_template( $atts['template_id'] );
	}

	// Titel setzen. Wenn er leer ist nehmen wir "Nächste Anlässe"
	$str_title = strlen( $atts['title'] ) > 0 ? $atts['title'] : __( 'Upcoming events', 'verowa-connect' );

	// Die Werte auf Integer wandeln.
	if ( isset( $_GET['event_page'] ) ) {
		$page_offset = abs( intval( $_GET['event_page'] ) );
	} else {
		$page_offset = 0;
	}

	$pro_seite = intval( $atts['pro-seite'] );
	$int_max = intval( $atts['max'] );

	// Absicherung, dass keine negativen Werte entstehen
	if ( $pro_seite < 1 ) {
		$pro_seite = $default_pro_seite;
	}

	if ( $int_max < 1 ) {
		$int_max = $default_max;
	}

	$seiten_aufteilen = $int_max > $pro_seite ? true : false;

	ob_start();

	// Fehlermeldung nur, falls nichts definiert (ob die Angabe überhaupt gültig ist,
	// wird durch die Verowa-Fn getestet; wir übergeben den Wert unverändert)
	if ( $atts['id'] == 0 && $atts['layer_id'] == '' && $atts['target_group'] == '' ) {
		echo '<mark>' . __( 'You need to enter a list ID or a layer ID for this list.', 'verowa-connect' ) .
			'</mark>';
	} elseif ($int_max > $max_max) {
		echo '<mark>' . sprintf( __( 'You can show %s events max.', 'verowa-connect' ), $max_max ) .
			'</mark>';
	} else {
		$event_offset = $page_offset * $pro_seite;
		// die Treffer der vorherigen Seiten müssen wir nicht mehr laden
		$anzahl_abholen = $int_max - $event_offset;

		// Falls auf die Seite weniger passen, als noch übrig sind, holen wir nur die Seite
		if ($pro_seite < $anzahl_abholen) {
			$anzahl_abholen = $pro_seite;
		}

		$arr_verowa_events = verowa_get_multiple_events_from_db( '', $atts['id'], $atts['target_group'],
			$atts['layer_id'], $anzahl_abholen);


// TODO: Was in dieser Version nicht mehr implementiert ist, ist die Möglichkeit, Seiten zu wechseln

		$number_of_all_entries = count ($arr_verowa_events);

		// auch die Seitenzahlen dürfen sich nur auf $max beziehen, falls es in der DB mehr Einträge gibt
		if ( $int_max < $number_of_all_entries ) {
			$anzahl_zeigen = $int_max;
		} else {
			$anzahl_zeigen = $number_of_all_entries;
		}

		if ( $seiten_aufteilen == true && $anzahl_zeigen > $pro_seite ) {
			$html_seitenzahlen_zeile = verowa_seitenzahl_anzeige( $anzahl_zeigen, $pro_seite ,'' );
			echo $html_seitenzahlen_zeile;
		}

		if ( $number_of_all_entries > 0 ) {
			echo '<div class="event_list_wrapper event_list_dynamic_agenda">';

			// Print the header
			if ( count( $arr_eventlist_template ) > 0 ) {
				echo $arr_eventlist_template['header'];
			}

			// falls der Titel nur Leerschläge enthält, wird nichts ausgegeben
			if ( strlen( trim( $str_title ) ) > 0 ) {
				echo '<h3>' . $str_title . '</h3>';
			}
		}

		foreach ( $arr_verowa_events as $arr_verowa_single_event ) {
			if ( strtotime( $arr_verowa_single_event['date_from'] ) < strtotime( current_time( 'd.m.Y' ) . ' +' . $atts['max_days'].' days' ) ) {
				echo show_single_verowa_event( $arr_verowa_single_event, intval( $atts['template_id'] ) );
			}
		}

		if ( $number_of_all_entries > 0 ) {

			// Print the footer
			if ( count( $arr_eventlist_template ) > 0 ) {
				echo $arr_eventlist_template['footer'];
			}

			echo '</div>';
		}

		if ( $seiten_aufteilen == true && $anzahl_zeigen > $pro_seite ) {
			echo $html_seitenzahlen_zeile;
		}
	}

	return ob_get_clean();
}



function verowa_event_liste( $atts ) {
	// Wo keine Werte gesetzt sind, werden Defaults verwendet

	// Wenn die Anzahl eingestellt ist und "Seiten aufteilen" auch auf True gesetzt ist,
	// gibt es mehrere Seiten mit der gesetzten Anzahl.

	$default_pro_seite = 10;
	$default_max = $default_pro_seite;

	$atts = shortcode_atts(
		array(
			'id' => 0,
			'layer_id' => '',
			'target_group' => '',
			'pro-seite' => $default_pro_seite ,
			'title' => '',
			'max' => $default_max,
			'max_days' => 365,
			'template_id' => 0,
		),
		$atts,
		'verowa_event_liste'
	);

	ob_start();

	// Wir geben alle attribute weiter
	echo do_shortcode('[verowa_event_list id=' . $atts['id'] . ' layer_id="' . $atts['layer_id'] . '" target_group="' .
		$atts['target_group'] . '" pro-seite=' . $atts['pro-seite'] . ' title="' . $atts['title'] . '" max=' .
		$atts['max'] . ' max_days=' . $atts['max_days'] . ' template_id=' . $atts['template_id'] . ']');

	return ob_get_clean();
}
?>