<?php

// Single Event
function show_single_verowa_event( $arr_event, $int_eventlist_template = 0 ) {
	global $post;

	$event_cats = '';
	$arr_placeholder = array();

	$arr_content = $arr_event['content'];

	// if no template id is given we get it from the post meta for this page
	if ( $int_eventlist_template == 0 ) {
		$int_eventlist_template = intval( get_post_meta( $post->ID, 'verowa_eventlist_template', true ) );

		// if there is no template id in the post meta either we get the default from the options
		if ( $int_eventlist_template == 0 ) {
			$int_eventlist_template = intval( get_option( 'verowa_default_eventlist_template' ) );
		}
	}

	$arr_eventlist_template = verowa_get_template( $int_eventlist_template );

	$arr_placeholder['EVENT_ID'] = $arr_content['event_id'];

	if ( isset( $arr_content['event_cats'] ) ) {
		$event_cats = str_replace( '.', '', $arr_content['event_cats']);
	}

	// Bereichs-IDs (die brauchen wir, um im Template Layer-abhängig die Texte zu ändern
	$arr_placeholder['LAYER_IDS'] = $arr_event['layer_ids']; // z.B. ";36;5;"

	$arr_coorganizer_names = [];
	if ( count( $arr_content['coorganizers'] ) > 0 ) {
		foreach ( $arr_content['coorganizers'] as $arr_single_coorg ) {
			$arr_coorganizer_names[] = $arr_single_coorg['name'];
		}
	}

	// Mitwirkende: Namen als String in einem Array
	$arr_coorganizer_names = [];
	if ( count( $arr_content['coorganizers'] ) > 0 ) {
		foreach ( $arr_content['coorganizers'] as $arr_single_coorg ) {
			$arr_coorganizer_names[] = $arr_single_coorg['name'];
		}
	}

	/** @deprecated v 2.4.0 */
	$arr_placeholder['EVENT-CATS'] = $event_cats;
	$arr_placeholder['DATE_FROM'] = date( 'Ymd', strtotime( $arr_content['date_from'] ) );
	$arr_placeholder['EVENT_DATE'] = show_single_verowa_event_date( $arr_content );
	$arr_placeholder['EVENT_TIME'] = show_single_verowa_event_time( $arr_content );
	$arr_placeholder['EVENT_TITLE'] = $arr_content['title'];
	// end deprecated

	$arr_placeholder['CATEGORIES'] = $event_cats;
	$arr_placeholder['DATE_FROM_8'] = date( 'Ymd', strtotime( $arr_content['date_from'] ) );
	$arr_placeholder['DATE_FROM_LONG'] = show_single_verowa_event_date( $arr_content );
	$arr_placeholder['TIME_MIXED_LONG'] = show_single_verowa_event_time( $arr_content );
	$arr_placeholder['TITLE'] = $arr_content['title'];

	$arr_placeholder['ORGANIZER_NAME'] = key_exists('name', $arr_content['organizer']) ?
		$arr_content['organizer']['name'] : '';

	$arr_placeholder['COORGANIZER_NAMES'] = implode( ', ', $arr_coorganizer_names );

	$arr_placeholder['WEEKDAY'] = strtolower( date( 'D', strtotime( $arr_content['date_from'] ) ) ); // z.B. "sat"


	// Es wird überprüft ob die Vernstaltung mehrtägig ist
	$verowa_date_from = new DateTime( $arr_content['date_from'] );
	$verowa_date_to = new DateTime( $arr_content['date_to'] );
	if ( ( $verowa_date_to->format( "U" ) - $verowa_date_from->format( "U" ) ) > 86400 ) {
		$date_format_string_from = 'D, j. F';
		$date_format_string_to = 'D, j. F Y';

		if ( date_i18n( "FY", $verowa_date_from->format('U') ) == date_i18n( "FY", $verowa_date_to->format('U') ) ) {
			$date_format_string_from = 'D, j.';
		}

		$arr_placeholder['DATETIME_LONG'] =  date_i18n( $date_format_string_from, $verowa_date_from->format('U') ) .
			', ' . _x( 'to', 'temporal', 'verowa-connect' ) . ' ' .
			date_i18n( $date_format_string_to, $verowa_date_to->format( 'U' ) );

	} else if ( get_option( 'show-to-time', false ) == 'on' ) {
		$arr_placeholder['DATETIME_LONG'] = $arr_content['date_text'];
	} else {
		$arr_placeholder['DATETIME_LONG'] = date_i18n( "D", $verowa_date_from->format( "U" ) ) . ', '.
			date_i18n( "j.", $verowa_date_from->format( "U" ) ).' '.
			date_i18n( "F Y", $verowa_date_from->format( "U" ) ).', '.
			date_i18n( "G.i", $verowa_date_from->format( "U" ) ) . ' ' .
			__( 'o’clock', 'verowa-connect' );
	}

	/** @deprecated EVENT_DATETIME_TEXT */
	$arr_placeholder['EVENT_DATETIME_TEXT'] = $arr_placeholder['DATETIME_LONG'];

	// Thema zeigen, falls vorhanden
    if ( $arr_content['topic'] != '' ) {
		$arr_placeholder['TOPIC'] = $arr_content['topic'];
	}

	// Ort
	if ( !empty( $arr_content['rooms'] ) ) {
    	$arr_placeholder['LOCATION_WITH_ROOM'] = show_single_verowa_event_location( $arr_content['rooms'][0] );
    	$arr_placeholder['LOCATIONS'] = show_single_verowa_event_location( $arr_content['rooms'][0] ); /** @deprecated */
	}

	// Bild
	if ( key_exists('list_image', $arr_content) && $arr_content['list_image'] != '' ) {
    	$arr_placeholder['IMAGE_URL'] = $arr_content['list_image'];
	}

	$arr_placeholder['CALENDAR_EXPORT'] = __( 'Calendar export', 'verowa-connect' );

	$str_datetime_now = date_i18n( 'Ymd' ) . date_i18n( 'His' );

	if ( empty( $arr_content['subscribe_time'] ) ) {
		$arr_content['subscribe_time'] = '2359';
	}

	// Anmeldebutton setzen wenn ein Formular ausgewählt wurde
	$arr_placeholder['SUPSCRIPTION_BUTTON'] = '';

	if ( ( 0 != $arr_content['subscribe_date'] ||
		(key_exists('subscription', $arr_content) && true == $arr_content['subscription']) ) &&
		$arr_content['subscribe_person_id'] > 1 ) {
		// disabled? (whenever the subscription date is set but expired)
		if ( $arr_content['subscribe_date'] > 0 && $arr_content['subscribe_date'] .
			$arr_content['subscribe_time'] . '59' < $str_datetime_now ) {
			$arr_placeholder['SUPSCRIPTION_BUTTON'] = '<button class="subscription disabled"' .
				' title="Die Anmeldefrist ist abgelaufen.">' . __( 'Subscription', 'verowa-connect' ) . '</button>';
		} else {
			$arr_placeholder['SUPSCRIPTION_BUTTON'] = '<a href="/subscription-form?subs_event_id=' .
				$arr_content['event_id'] .
				'"><button class="subscription">' . __( 'Subscription', 'verowa-connect' ) . '</button></a>';
		}
	}

	// Detailbutton ändern wenn kein Formular ausgewählt wurde aber es trotzdem eine Anmeldezeit hat
	if ( 0 != $arr_content['subscribe_date'] && $arr_content['subscribe_person_id'] == 0
		&& $arr_content['subscribe_date'] . $arr_content['subscribe_time'] . '59' > $str_datetime_now ) {

		$arr_placeholder['DETAILS_BUTTON_TEXT'] = __( 'Details + Subscription', 'verowa-connect' );
	} else {
		$arr_placeholder['DETAILS_BUTTON_TEXT'] = __( 'Details', 'verowa-connect' );
	}

	$str_output = verowa_parse_template( $arr_eventlist_template['entry'], $arr_placeholder ) .
		$arr_eventlist_template['separator'];

	return $str_output;
}

function show_single_verowa_event_date( $event ) {
	$verowa_date_from = new DateTime( $event['date_from'] );
	$verowa_date_to = new DateTime( $event['date_to'] );
	$verowa_date_from_ts = $verowa_date_from->format( 'U' );


	// Der Kalender Tag wird nur angezeigt wenn das Event nicht mehrere Tage lang dauert
	if ( date_i18n( 'Ymd', $verowa_date_from_ts ) == date_i18n( 'Ymd', $verowa_date_to->format( 'U' ) ) ) {
		$str_date_from_year = $verowa_date_from->format( 'Y' );
		$str_year_now = date_i18n( 'Y' );
		$str_month = date_i18n( 'F', $verowa_date_from_ts );
		$str_year  = date_i18n( 'Y', $verowa_date_from_ts );
		$arr_month_kurz = [
			'01' => 'Jan.',
			'02' => 'Feb.',
			'03' => 'März',
			'04' => 'April',
			'05' => 'Mai',
			'06' => 'Juni',
			'07' => 'Juli',
			'08' => 'Aug.',
			'09' => 'Sept.',
			'10' => 'Okt.',
			'11' => 'Nov.',
			'12' => 'Dez.'
		];

		$str_month_year_html = '<span class="month">' . $str_month . '</span>';

		// Wenn das Jahr nicht das jetzige ist (Kann nur in der Zukunft liegen), dann geben wir es aus
		if ( $str_date_from_year != $str_year_now ) {
			$str_month = $arr_month_kurz[date_i18n( 'm', $verowa_date_from_ts )];
			$str_year = date_i18n( 'y', $verowa_date_from_ts );

			// Beispiel: Januar 2022 -> Jan. 2022
			$str_month_year_html = '<span class="month year">' . $str_month . ' ' . $str_year . '</span>';
		}

		$date_string =
			'<span class="weekday">' . date_i18n( 'l', $verowa_date_from_ts ) . '</span>' .
			'<span class="day">' . date_i18n( 'j', $verowa_date_from_ts ) . '</span>' .
			$str_month_year_html;
	} else {
		// wenn der Event mehrtägig ist, können wir ihn nicht via Kalender zeigen; in diesem Fall lassen wir diese
		// Felder leer und zeigen die Daten dort, wo sonst die Zeit steht (siehe Fn show_single_verowa_event_time)
		$date_string =
			'<span class="weekday"></span><span class="day"></span>' .
			'<span class="month"></span><span class="year"></span>';
	}

	return $date_string;
}



function show_single_verowa_event_time( $event ) {
	$verowa_date_from = new DateTime( $event['date_from'] );
	$verowa_date_to = new DateTime( $event['date_to'] );
	$verowa_date_from_ts = $verowa_date_from->format( 'U' );
	$verowa_date_to_ts = $verowa_date_to->format( 'U' );

	$time_string = '<span class="time">';

	// falls es ein eintägiger Event ist, können wir die Zeit direkt ausgeben
	if ( date_i18n( 'Ymd', $verowa_date_from_ts ) == date_i18n( 'Ymd', $verowa_date_to_ts ) ) {
		$time_string .= date_i18n( 'G.i', $verowa_date_from_ts );

		if ('on' == get_option( 'show-to-time', false ) ) {
			$time_string .= '&ndash;' . date_i18n( 'G.i', $verowa_date_to_ts );
		}

		$time_string .= ' ' . __( 'o’clock', 'verowa-connect' );
	} else {
		// bei mehrtägigen Events nehmen wir ein anderes Format (3 Varianten):
		// von/bis im selben Monat: "9.–13. September 2019"
		if ( date_i18n( 'M Y', $verowa_date_from_ts ) == date_i18n( 'M Y', $verowa_date_to_ts ) ) {
			$time_string .= date_i18n( 'j.', $verowa_date_from_ts ) . '&ndash;' .
				date_i18n( 'j. F Y', $verowa_date_to_ts );
		}
		// wenn es über 2 Monate im selben Jahr geht: "27. September bis 18. Oktober 2019"
		elseif ( date_i18n( 'Y', $verowa_date_from_ts ) == date_i18n( 'Y', $verowa_date_to_ts ) ) {
			$time_string .= date_i18n( 'j. F', $verowa_date_from_ts ) . ' ' .
				_x( 'to', 'temporal', 'verowa-connect' ) . ' ' .
				date_i18n( 'j. F Y', $verowa_date_to_ts );
		}
		// wenn es über eine Jahresgrenze geht: "30. Dezember 2019 bis 3. Januar 2020"
		else {
			$time_string .= date_i18n( 'j. F Y', $verowa_date_from_ts ) . ' ' .
				_x( 'to', 'temporal', 'verowa-connect' ) . ' ' .
				date_i18n( 'j. F Y', $verowa_date_to_ts );
		}
	}

	$time_string .= '</span>';

	return $time_string;
}



/**
 * Summary of show_single_verowa_event_location
 *
 * @param array $arr_event_loc
 *
 * @return string
 */
function show_single_verowa_event_location( $arr_event_loc ) {
	$arr_loc_parts = [];

	if ( isset( $arr_event_loc['location_name'] ) ) {
		$arr_loc_parts[] = $arr_event_loc['location_name'];
	}

	if ( isset( $arr_event_loc['name'] ) && !in_array( $arr_event_loc['name'], $arr_loc_parts ) ) {
		$arr_loc_parts[] = $arr_event_loc['name'];
	}

	return implode( ', ', $arr_loc_parts );
}

?>