<?php

// Funktionsdatei, um Verowa-Daten an die Suche anzuhängen;
// das wird über den Filter als Fake Post direkt über die Verowa-API gemacht.

add_filter( 'the_posts', 'verowa_event_search_items', 2 );


function verowa_event_search_items( $posts ) {
	global $wp, $wp_query;

	if ( $wp_query->is_search && !is_admin() ) {
		$temp_posts = $posts;
		$posts = array();

		// Events
		$verowa_call_string = '%20/0/10000';
		
		// Personen und Veranstaltungen aus Verowa holen
		$arr_verowa_events = verowa_api_call( 'geteventsbylist', $verowa_call_string, true );
		$arr_all_persons = verowa_api_call( 'getpersonsbyid', '0', true );
		$event_fake_pages = array();

		// Persons
		foreach ( $arr_all_persons as $person ) {
			$s1 = strpos( strtolower( $person['firstname'] . ' ' . $person['lastname'] ),
				strtolower( $wp_query->query['s'] ) );
			$s2 = strpos( strtolower( $event['long_desc']) , strtolower( $wp_query->query['s'] ) );

			if (is_int( $s1 ) || is_int( $s2 ) ) {
				$fake_person = (object) array(
					'ID' => '-' . $person['person_id'],
					'post_title' => $person['firstname'] . ' ' . $person['lastname'],
					'post_content' => $person['main_group_text'] . ' ' . $person['short_desc'],
					'post_name' => '/person/' . $person['person_id'] . '/',
					'post_date' => '2018-06-22 00:00:00',
					'comment_status' => 'closed',
					'post_type' => 'person' // Fake Post Type für eine Person
				);
				$event_fake_pages[] = $fake_person;
			}
		}

		// create the posts
		foreach ( $event_fake_pages as $key => $fake) {
			$posts[] = $fake;
			unset( $event_fake_pages[$key] );
		}

		$posts = array_merge( $posts, $temp_posts );

		// Events
		foreach ( $arr_verowa_events['events'] as $event ) {
			$s1 = strpos( strtolower( $event['title'] ), strtolower( $wp_query->query['s'] ) );
			$s2 = strpos( strtolower( $event['long_desc'] ), strtolower( $wp_query->query['s'] ) );

			if ( is_int( $s1 ) || is_int( $s2 ) ) {
				$fake_event = (object) array(
					'ID' => '-' . $event['event_id'],
					'post_title' => $event['title'] . '<span style="display:block" class="search-date">' .
						$event['date_text'] . '</span>',
					'post_content' => $event['long_desc'],
					'post_name' => '/veranstaltung/' . $event['event_id'] . '/',
					'post_date' => '2018-06-22 00:00:00',
					'comment_status' => 'closed',
					'post_type' => 'event'
				);

				$event_fake_pages[] = $fake_event;
			}
		}
		
		// create the posts
		foreach ( $event_fake_pages as $fake ) {
			$posts[] = $fake;
		}
	}

	return $posts;
}
?>