<?php
/*
 * Diese Funktionen liest die Daten aus API.Verowa.ch aus.
 * Sie deckt nur noch einen API Aufruf ab.
 * "Reines REST" und "SOAP als REST"
 */

function verowa_api_call( $method, $id, $soap_is_on = false ) {
	$api_url = 'https://api.verowa.ch/';
	$instance = get_option( 'verowa_instance', true );
	$api_key = get_option( 'verowa_api_key', true );

	// Ändert die URL-Struktur je nachdem ob SOAP Funktionen an sind
	if ( true == $soap_is_on ) {
		$the_verowa_api_query = $api_url . $method . '/' . $instance . '/' . $api_key . '/' . $id;
	} else {
		$desired_id = ( '' == $id) ? '' :  $id . '/';
		$the_verowa_api_query = $api_url.$method . '/' . $instance . '/' . $desired_id.$api_key;
	}

	$json = wp_remote_retrieve_body( wp_remote_get( $the_verowa_api_query ) );
	$data = json_decode( $json, true );

	return $data;
}

function verowa_get_eventdetails($arr_api_event_ids)
{
	$verowa_api_key = get_option( 'verowa_api_key', false );
	$verowa_member = get_option( 'verowa_instance', false );
	$verowa_api_url = 'https://api.verowa.ch';
	$arr_ret = [];

	$arr_api_event_infos = 	wp_remote_post($verowa_api_url . '/geteventdetails', [
		'method' => 'POST',
		'timeout' => 45,
		'redirection' => 5,
		'httpversion' => '1.0',
		'blocking' => true,
		'headers' => [ 'member' => $verowa_member, 'apikey' => $verowa_api_key ],
		'body' => json_encode($arr_api_event_ids , true ),
		'cookies' => []
	]);

	if ( key_exists('body', $arr_api_event_infos) ) {
		$arr_ret = json_decode($arr_api_event_infos['body'], true);
	}
	return $arr_ret;
}

?>