<?php
/*
 * Diese Funktion legt die fingierten Posts für Veranstaltungen und Personen an;
 * da diese offiziell nicht existieren, werden sie über eine 404-Seite generiert.
 * Abhängig vom Request entweder /veranstaltung/ oder /person/
 */


add_shortcode( 'verowa_generate_post_event', 'verowa_generate_post_event' );
add_shortcode( 'verowa_generate_post_person', 'verowa_generate_post_person' );

add_filter( 'the_title', 'verowa_post_title' );
add_filter( 'body_class', 'verowa_person_body_class' );
add_filter( 'body_class', 'verowa_event_body_class' );

/**
 * Eventdetailseiten anzeigen
 *
 */
function verowa_generate_post_event( $atts ) {
	global $post, $wp_query, $wpdb;

	$str_content = '';

	$atts = shortcode_atts(
		array(
			'verowa_id' => 0,
			'type' => '',
		),
		$atts,
		'verowa_generate_post_event'
	);

	// Event ID auslesen. Kann auch als attribut dem shortcode übergeben um ein spezifisches Event auszulesen
	$int_id = intval( $atts['verowa_id'] ) == 0 ? intval( $wp_query->query_vars['verowa_id'] ) : $atts['verowa_id'];

	// Eventdetails holen
	$str_content = get_verowa_event_single_content( $int_id );

	ob_start ();

	echo $str_content;

	return ob_get_clean();
}



/**
 * Personendetailseiten anzeigen
 *
 */
function verowa_generate_post_person( $atts ) {
	global $post, $verowa_event_title, $wp_query;

	$str_content = '';

	$atts = shortcode_atts(
		array(
			'verowa_id' => 0,
			'type' => '',
		),
		$atts,
		'verowa_generate_post_person'
	);

	// Personen ID auslesen. Kann auch als attribut dem shortcode übergeben um eine spezifische Person darzustellen
	$int_id = intval( $atts['verowa_id'] ) == 0 ? intval( $wp_query->query_vars['verowa_id'] ) : $atts['verowa_id'];

	// Infos zu der Person holen
	$str_content = show_a_person_from_verowa_detail( $int_id );
	
	ob_start ();

	echo $str_content;
	
	return ob_get_clean();
}


function verowa_post_title( $str_title ) {
	if ( !is_admin() && ( $str_title == 'Veranstaltungsdetails' || $str_title == 'Personendetails' ) ) {
		$str_title = '';
	}

	return $str_title;
}


// Die HTML-Titel werden hier generiert.
function verowa_event_wp_title_return( $title ) {
	global $verowa_event_title;

	return get_bloginfo( 'name' ) .' - ' . $verowa_event_title;
}



function verowa_person_wp_title_return( $title ) {
	global $verowa_personen_title;

	return get_bloginfo( 'name' ) .' - ' . $verowa_personen_title;
}




function verowa_event_body_class( $classes ) {
	global $post;

	if ( $post->post_title == 'Veranstaltungsdetails' ) {
		$classes[] = 'verowa_event_body';
	}

	return $classes;
}



function verowa_person_body_class( $classes ) {
	global $post;

	if ( $post->post_title == 'Personendetails' ) {
		$classes[] = 'verowa_person_body';
	}

	return $classes;
}



function verowa_unlink_post_title( $title ) {
	return '<h2 class="entry-title" itemprop="headline">' . wp_filter_nohtml_kses( $title ) . '</h2>';
}
?>