<?php

function activate_verowa_data_hooks() {
	if ( !wp_next_scheduled( 'sync_verowa_data_from_api' ) ) {
		wp_schedule_event( time(), 'hourly', 'sync_verowa_data_from_api' );
	}
}

function deactivate_verowa_data_hooks() {
	wp_clear_scheduled_hook( 'sync_verowa_data_from_api' );
}

add_action( 'sync_verowa_data_from_api', 'sync_verowa_data_from_api_process' );


/**
 * Activate Config. also use this function
 *
 * @return bool
 */
function sync_verowa_data_from_api_process() {
	global $wpdb;


	$obj_update_controller = new Verowa_Update_Controller();
	$obj_update_controller->update_agenda_filters();
	$obj_update_controller->update_verowa_events_in_db();
	$obj_update_controller->update_verowa_persons_in_db();
	return true;
}


add_action(
	'rest_api_init',
	function () {
		register_rest_route(
			'verowa/v1',
			'/update/(?P<slug>[a-zA-Z0-9-]+)',
			array(
				'methods' => 'GET',
				'callback' => 'sync_verowa_data_from_api_process'
			)
		);
	}
);
?>