﻿/* Dynamic Agenda JS,
 */

// infinite-scroll
var g_max_loadings = 50; // Maximale Anzahl des neuladens
var g_current_batch = 2; // Anzahl neu geladener Einträge, Der erste Batch wird per PHP geladen.
var g_agenda_is_loading = false;
var g_has_further_results = true;
var g_filter_has_changed = false; // Wird auf True gesetzt, wenn sich der Filter während des Ladens geändert hat.


/*
 *  So wird verhindert, dass ein Klick auf den Kalender oder die Details den Agenda-Eintrag schliessen
 */
function event_handler_detail_link_clickt(e) {
	e.stopPropagation();
}

jQuery(document).ready(function ($) {

	$(document).on('click touch', ".event_list_item a", function (e) {
		e.stopPropagation();
	});

	// toggle for details
	jQuery(document).on('click touch', '.event_list_dynamic_agenda .event_list_item', function (e) {
		e.preventDefault();
		var event_id = $(this).attr('data-id');
		
		if ($(this).find('.toggle_button').hasClass('open')) {
			$('.event-' + event_id + ' .short_text').toggle();
			$('.event-' + event_id + ' .event_button_list').toggle();
			$('.event-' + event_id + ' .event_content').html('');
			$(this).find('.toggle_button.open').removeClass('open');
			$(this).find('.toggle_button').css({ 'transform': 'rotate(0deg)' });
		}
		else
		{
			$(this).find('.toggle_button').addClass('open');
			$(this).find('.toggle_button').css({ 'transform': 'rotate(180deg)' });
			jQuery.getJSON({
				url: "/wp-json/verowa/v1/event/" + event_id,
				data: '',
				success: function (data) {
					console.log(data);
					$('.event-' + event_id + ' .short_text').toggle();
					$('.event-' + event_id + ' .event_button_list').toggle();

					var expanded_event_html = '<div class="first"></div>';

					if (data['short_desc'] != 'undefined') {
						expanded_event_html += '<p class="short_desc">' + data['short_desc'] + '</p>';
					}

					// Event Meta
					var event_meta = '';

					if (data['catering'] != null && data['catering'].toString() != '') {
						event_meta += ', <span class="catering">' + data['catering'] + '</span>';
					}
					// 
					if (data['childcare_text'] != null && data['childcare_text'].toString() != '') {
						event_meta += ', <span class="childcare_text">' + data['childcare_text'] + '</span>';
					}
					// 
					if (data['baptism_offer_text'] != null && data['baptism_offer_text'].toString() == 'ja') {
						event_meta += ', <span class="baptism_offer_text">mit Taufe</span>';
					}

					if (event_meta != '') {
						expanded_event_html += '<p class="event_meta">';
						expanded_event_html += event_meta.replace(', ', '');
						expanded_event_html += '</p>';
					}

					// Organizer String
					var organizers = '';


					if (data['organizer'] != null && data['organizer'].toString() !== '') {

						organizers += ', ' + data['organizer']['name'];
					}

					$.each(data['coorganizers'], function (index, value) {

						organizers += ', ' + value['name'];
					});

					if (data['further_coorganizer'] != null && data['further_coorganizer'].toString() !== '') {

						organizers += ', ' + data['further_coorganizer'];
					}


					if (organizers != '') {
						expanded_event_html += '<p class="organizers">';
						expanded_event_html += organizers.replace(', ', '');
						expanded_event_html += '</p>';
					}


					$('.event-' + event_id + ' .event_content').html(expanded_event_html);


					var LinkNodeList = document.querySelectorAll(".event_button_list a:not(.icalhandler)");
					for (let node of LinkNodeList) {
						node.addEventListener("click", event_handler_detail_link_clickt);
					}
				}
			});
		}
	});

	jQuery(document).on('click touch', '.icalhandler', function (e) {
		e.preventDefault();
		e.stopPropagation();
		var event_id = $(this).attr('data-id');
		window.location = "/wp-json/verowa/v1/ical/" + event_id + "?format=ical";
	});

	// we need this, that the toogle is not triggered in this moment
	// Event anstelle von e als Parameter kann zu Fehler führen
	jQuery('.details-button').on('click touch', function (e) {
		e.stopPropagation();
	});

	// Das ist die Original Function vom Isotope.
	// Diese hat keine "Combinations mehr ****
	$(document).on('click', '#verowa_event_filters .list_filter a', function () {

		var $this = $(this);
		// don't proceed if already selected
		if ($this.hasClass('selected')) {
			return;
		}

		var $optionSet = $this.parents('.option-set');
		// change selected class
		$optionSet.find('.selected').removeClass('selected');
		$this.addClass('selected');

		if (!g_agenda_is_loading) {
			load_agenda_events(true);
			g_agenda_is_loading = true;
		} else {
			g_filter_has_changed = true;
		}

		return false;
	});

	// on change of datepicker we need to the same as when we change a filter
	jQuery('#verowa_connect_datepicker').change(function () {
		var $this = $(this);

		var selector = '';
		var vlist_ids = '%20';

		if (!g_agenda_is_loading) {
			load_agenda_events(true);
			g_agenda_is_loading = true;
		} else {
			g_filter_has_changed = true;
		}

		return false;
	});
});


// Datepicker Selector
var dateToday = new Date();

jQuery(function () {
	// German strings in here, because we never know what jQuery UI language is set
	jQuery("#verowa_connect_datepicker").datepicker({
		dateFormat: "dd.mm.yy",
		monthNames: ["Januar", "Februar", "März", "April",
			"Mai", "Juni", "Juli", "August", "September",
			"Oktober", "November", "Dezember"
		],
		minDate: dateToday,
		firstDay: 1, // Start with Monday
		dayNamesMin: ["So", "Mo", "Di", "Mi", "Do", "Fr", "Sa"]
	});

	// Also calendar icon triggers datepicker
	jQuery(".dashicons-calendar-alt").on("click", function () {
		// Wenn man den Kalendar klickt geht der Datepicker auch auf
		jQuery("#verowa_connect_datepicker").focus();

	});

});

function datepicker_to_technical_date() {
	var filterDate = '';
	if (document.getElementById("verowa_connect_datepicker") != null) {
		var filterDateRaw = document.getElementById("verowa_connect_datepicker").value;
		// this is because we need 20181012 format for the date
		var filterDateArr = filterDateRaw.split(".");
		filterDateArr = filterDateArr.reverse();
		filterDate = filterDateArr.join('');
	}

	return filterDate;
}


// infinite-scroll
function load_agenda_events(reload) {
	
	jQuery("#infinite-scroll-loader").show();

	if (reload) {
		g_current_batch = 1;
		jQuery('.event_list_dynamic_agenda').html("");
		g_has_further_results = true;
	}

	var date_from_datepicker = datepicker_to_technical_date();

	var obj_data = {
		date: date_from_datepicker,
		arr_list_ids: [] 
	};

	jQuery('#verowa_event_filters .list_filter a.selected').each(function (index, ele) {
		if (jQuery(ele).attr("data-filter-value") != "")
		{
			obj_data.arr_list_ids.push(parseInt(jQuery(ele).attr("data-filter-value").split('-')[1]));
		}
	});

	jQuery.ajax({
		url: '/wp-json/verowa/v1/agenda_event/' + g_current_batch + '/',
		type: 'GET',
		data: obj_data,
		contentType: "application/json; charset=utf-8",
		dataType: "JSON",
		success: function (data) {
			g_current_batch++;
			jQuery(".event_list_dynamic_agenda").append(data.content);
			g_agenda_is_loading = false;
			jQuery("#infinite-scroll-loader").hide();

			// Keine Resultate?
			if (jQuery(".event_list_dynamic_agenda > div").length == 0) {
				jQuery('#no-events-box').show();
			} else {
				jQuery('#no-events-box').hide();
			}
			g_has_further_results = data.has_further_results;

			if (g_has_further_results){
				if (g_filter_has_changed) {
					g_filter_has_changed = false;
					load_agenda_events(true);
				}
			}
		},
		error: function (request, status, error) {
			g_agenda_is_loading = false;
			g_has_further_results = true;
			if (g_filter_has_changed) {
				g_filter_has_changed = false;
				load_agenda_events(true);
			}
		}
	});
}

function bind_infinite_scroll() {

	window.addEventListener('scroll', () => {
		const {
			scrollTop,
			scrollHeight,
			clientHeight
		} = document.documentElement;

		if (scrollTop + clientHeight >= scrollHeight - 5
			&& g_current_batch < g_max_loadings && g_has_further_results) {
			if (!g_agenda_is_loading) {
				load_agenda_events(false);
				g_agenda_is_loading = true;
			}
		}
	}, {
		passive: true
	});
}

function scroll_to_event(event_id)
{
	if (jQuery(".event-" + event_id).length >= 1 && event_id !== 0 && event_id != null)
	{
		var int_event_offset_top = jQuery(".event-" + event_id).offset().top;
		var int_sticky_navigation = jQuery(".inside-navigation").height() || 0;
		var int_martin_top = 30;

		var scoll_to_px = int_event_offset_top - int_sticky_navigation - int_martin_top;

		jQuery("html, body").animate({
			scrollTop: scoll_to_px
		}, 0);
	}
}	

function verowa_agenda_filter_reset()
{
	var obj_date_now = new Date();
	var str_day = '0' + obj_date_now.getDate();
	if (obj_date_now.getDate() > 9)
	{
		str_day = obj_date_now.getDate();
	}

	var int_month = obj_date_now.getMonth() + 1;
	var str_month = '0' + int_month;
	if (int_month > 9) {
		str_month = int_month;
	}

	var str_date_now = str_day + '.' + str_month + '.' + obj_date_now.getFullYear();
	jQuery('#verowa_connect_datepicker').val(str_date_now);
	jQuery("#verowa_event_filters .filter-button.selected").removeClass("selected");
	jQuery("#verowa_event_filters .no-filter:not(.selected)").addClass("selected");
	load_agenda_events(true);
}