<?php
/**
 * Fügt eine sogenannte Custom Meta Box hinzu, die für die Personen-Zuordnung benötigt wird.
 *
 */

add_action( 'add_meta_boxes', 'verowa_person_assign_add_meta_box' );
add_action( 'save_post', 'verowa_person_assign_save_meta_box_data' );
add_filter( 'the_content', 'add_verowa_persons_if_selected', 7 );

function verowa_person_assign_add_meta_box() {
	$screens = array(
		'post',
		'page'
	);

	foreach ( $screens as $screen ) {
		add_meta_box( 'verowa_person_assign_sectionid', __( 'Assign persons', 'verowa-connect' ),
			'verowa_person_assign_meta_box_callback', $screen );
	}
}



// Callback der oben genannten Funktion
function verowa_person_assign_meta_box_callback( $post ) {
	global $wpdb;

	$str_single_or_group = get_post_meta( $post->ID, '_verowa_person_assign', true );
	$int_group_id = get_post_meta( $post->ID, '_verowa_person_group', true );
	$include_subgroups = get_post_meta( $post->ID, '_verowa_person_subgroup', true );
	$pers_groups_title = get_post_meta( $post->ID, '_verowa_person_group_title', true );

	wp_nonce_field( 'verowa_person_assign_meta_box', 'verowa_person_assign_meta_box_nonce' );
	echo '<div class="row"><div class="col col-md-6">';

	$arr_group_data = verowa_api_call( 'getpersongroups', '' );
	$verowa_group_dropdown = verowa_group_dropdown( $arr_group_data );
	$arr_all_persons = verowa_api_call( 'getpersonsbyid', '0', true );
	$verowa_person_dropdown = verowa_person_dropdown( $arr_all_persons );

	$int_selected_template = intval( get_post_meta( $post->ID, 'verowa_personlist_template', true ) );

	// Alle Personen-Templates holen
	$arr_show_persons_templates = verowa_get_person_template();

	echo '<span id="plusperson">' .
		'<span style="vertical-align:middle;" class="dashicons dashicons-plus-alt" ></span> ' .
		__( 'Add person', 'verowa-connect' ) . '</span><br />';

	echo '<span id="plusgroup">' .
		'<span style="vertical-align:middle;" class="dashicons dashicons-plus-alt" ></span> ' .
		__( 'Add group', 'verowa-connect' ) . '</span><br />';

	echo '<span id="plustext">' .
		'<span style="vertical-align:middle;" class="dashicons dashicons-plus-alt" ></span> ' .
		__( 'Add caption', 'verowa-connect' ) . '</span>';

	// jQuery muss leider ausserhalb von echo stehen, da es mehrere Anführungszeichen verwendet.
?>
	<script>
		var plusbutton = document.getElementById('plusperson');
		var plustext = document.getElementById('plustext');

		jQuery("#plusgroup, #plusperson").on('click', function() {
		var text =  jQuery('select[name="personeneinzeln"] option:selected' ).text();

		if (jQuery(this).attr("id") == 'plusperson') {
			jQuery( ".personen" ).append( "<li id='person_single'><span class='dashicons dashicons-move'></span><span class='dashicons dashicons-admin-users'></span><?php echo $verowa_person_dropdown; ?><a href='#' id='kill'> <span class='dashicons dashicons-dismiss'></span></a></li>" );
		} else {
			jQuery( ".personen" ).append( "<li id='person_single'><span class='dashicons dashicons-move'></span><span class='dashicons dashicons-groups'></span><?php echo $verowa_group_dropdown; ?><a href='#' id='kill'> <span class='dashicons dashicons-dismiss'></span></a></li>" );
		} });

		plustext.addEventListener('click', function() {
			var value = jQuery('select[name="personeneinzeln"]').val();
			var text =  jQuery('select[name="personeneinzeln"] option:selected' ).text();
			jQuery( ".personen" ).append( "<li id='person_single'><span class='dashicons dashicons-move'></span><span class='dashicons dashicons-format-aside'></span><input type='text' name='personeneinzeln[]' /></a><a href='#' id='kill'><span class='dashicons dashicons-dismiss'></span></a></li>" );
		}, false);

		jQuery( function() {
			jQuery(document).on('click touch', "#kill", function() { jQuery(this).parent().remove(); });
			jQuery( ".personen" ).sortable();
			jQuery( ".personen" ).disableSelection();
		} );

	</script>
	<style>
	.personen a, #plustext, #plusperson {
		text-decoration: none;
	}

	.col {
		display: inline-block;
		width: 49%;
		vertical-align: top;
	}

	.row {
		display: flex;
		width: 100%;
		vertical-align: top;
	}

	.verowa-personlist-template, .verowa-personlist-options {
		width: 50%;
	}

	</style>
<?php
	echo '<ul class="personen">';

	$arr_alle_einzelnen_person = get_post_meta( $post->ID, '_person_singles', true );
	$arr_alle_personen = $arr_all_persons;

	if ( is_array( $arr_alle_einzelnen_person ) ) {
		foreach ( $arr_alle_einzelnen_person as $str_einzelne_person ) {
			$name_array = array_search( $str_einzelne_person, array_column( $arr_alle_personen, 'person_id' ) );
			$name = $arr_alle_personen[$name_array]['firstname'];
			
			if ( strlen( $name ) > 0 && strlen( $arr_alle_personen[$name_array]['lastname'] ) > 0 ) {
				$name .= ' ';
			}

			$name .= $arr_alle_personen[$name_array]['lastname'];

			if ( '' != $str_einzelne_person && is_numeric( $str_einzelne_person ) ) {
				echo '<li id="person_single"><span class="dashicons dashicons-move"></span>' .
					'<span class="dashicons dashicons-admin-users"></span>' .
					stripslashes( verowa_person_dropdown( $arr_all_persons, $str_einzelne_person ) ) .
					'<a href="#" id="kill"> <span class="dashicons dashicons-dismiss"></span></a></li>';
			} elseif ( false !== strpos( $str_einzelne_person, 'group-' ) ) {
				echo '<li id="person_single"><span class="dashicons dashicons-move"></span>' .
					'<span class="dashicons dashicons-groups"></span>' .
					stripslashes( verowa_group_dropdown( $arr_group_data, str_replace( 'group-', '', $str_einzelne_person ) ) ) .
					'<a href="#" id="kill"> <span class="dashicons dashicons-dismiss"></span></a></li>';
			} else {
				echo '</span><li id="person_single"><span class="dashicons dashicons-move"></span>' .
					'<span class="dashicons dashicons-format-aside"></span>' .
					'<input type="text" name="personeneinzeln[]" value="' . $str_einzelne_person . '" /></a>' .
					'<a href="#" id="kill"><span class="dashicons dashicons-dismiss"></span></a></li>';
			}
		}
	}

	echo '</ul></div>';
	echo '<div class="col col-md-6" style="display: flex; flex-direction: row;"><div class="verowa-personlist-template"><h4>' . 
		__( 'Select Persons Template', 'verowa-connect' ) . '</h4>' . 
		verowa_show_template_dropdown( 'personlist', $int_selected_template ) . '</div>';
	echo '<div class="verowa-personlist-options">' . verowa_person_options_html() . '</div></div>';
}



/**
 * Die Daten der oben erzeugten Metabox werden abgespeichert.
 * Da das zu 50% aus WP-Eigenem Code besteht, werden die Original-Kommentare behalten.
 *
 * @param int     $post_id The ID of the post being saved.
 */

function verowa_person_assign_save_meta_box_data( $post_id ) {
	// Alle Sicherheiten durchgehen
	if ( !isset( $_POST['verowa_person_assign_meta_box_nonce'] ) ||
		!wp_verify_nonce( $_POST['verowa_person_assign_meta_box_nonce'], 'verowa_person_assign_meta_box' ) ||
		defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE || !current_user_can( 'edit_page', $post_id ) ) {
		
		return;
	}

	// Sanitize user input.
	$verowa_person_assign = sanitize_text_field( $_POST['personen'] );
	$verowa_personen_group = sanitize_text_field( $_POST['persongroup'] );
	$verowa_personen_subgroup = sanitize_text_field( $_POST['include_subgroups'] );
	$pers_groups_title = sanitize_text_field( $_POST['pers_group_title'] );
	
	// Update the meta field in the database.
	update_post_meta( $post_id, '_verowa_person_assign', $verowa_person_assign );
	update_post_meta( $post_id, '_verowa_person_group', $verowa_personen_group );
	update_post_meta( $post_id, '_verowa_person_subgroup', $verowa_personen_subgroup );
	update_post_meta( $post_id, '_verowa_person_group_title', $pers_groups_title );

	// Neue Optionen auf Post Ebene
	update_post_meta( $post_id, 'verowa_person_has_detail_page',
		isset( $_POST['verowa_person_has_detail_page'] ) ? 'on' : false );
	update_post_meta( $post_id, 'verowa_person_show_group_function',
		isset( $_POST['verowa_person_group_function'] ) ? 'on' : false );
	update_post_meta( $post_id, 'verowa_person_show_profession',
		isset( $_POST['verowa_person_profession'] ) ? 'on' : false );
	update_post_meta( $post_id, 'verowa_person_show_address',
		isset( $_POST['verowa_person_address'] ) ? 'on' : false );
	update_post_meta( $post_id, 'verowa_person_show_person_email',
		isset( $_POST['verowa_person_email'] ) ? 'on' : false );
	update_post_meta( $post_id, 'verowa_person_show_person_phone',
		isset( $_POST['verowa_person_phone'] ) ? 'on' : false );
	update_post_meta( $post_id, 'verowa_person_short_desc',
		isset( $_POST['verowa_person_short_desc'] ) ? 'on' : false );
	update_post_meta( $post_id, 'verowa_has_person_options_on_post_level', true );

	update_post_meta( $post_id, '_person_singles', $_POST['personeneinzeln'] );

	update_post_meta( $post_id, 'verowa_personlist_template', intval( $_POST['verowa_select_template_personlist'] ) );
}



function verowa_person_dropdown( $arr_all_persons, $selected = '' ) {
	$html = '<select id="personselect" name="personeneinzeln[]">';

	foreach ( $arr_all_persons as $arr_einzelne_person ) {
		$html .= '<option value="' . $arr_einzelne_person['person_id'] . '" ';

		if ( $selected == $arr_einzelne_person['person_id'] ) {
			$html .= ' selected=selected ';
		}

		$html .= '>' . $arr_einzelne_person['firstname'];

		if ( '' != $arr_einzelne_person['firstname'] && '' != $arr_einzelne_person['lastname'] ) {
			$html .= ' ';
		}

		$html .= $arr_einzelne_person['lastname'] . '</option>';
	}

	$html .= '</select>';

	return addslashes( $html );
}



function verowa_group_dropdown( $arr_group_data, $selected = '' ) {
	$html = '<select id="personselect" name="personeneinzeln[]">';
	$str_option_name = '';

	foreach ( $arr_group_data as $arr_group_single_data ) {
		$html .= '<option value="group-' . $arr_group_single_data['group_id'] . '"';
		
		if ( $selected == $arr_group_single_data['group_id'] ) {
			$html .= ' selected ';
		}

		$str_option_name = $arr_group_single_data['parent_id'] != 0 ? 
			'&nbsp;&nbsp;&nbsp;&nbsp;' . $arr_group_single_data['name'] : $arr_group_single_data['name'];

		$html .= '>' . $str_option_name . '</option>';
	}

	$html .= '</select>';

	return addslashes( $html );
}



/**
 * Add the selected persons to the page content
 * 
 */
function add_verowa_persons_if_selected( $content ) {
	global $post, $wp_query, $wpdb;

	$arr_template_in_content = [];

	$int_selected_template = get_post_meta( $post->ID, 'verowa_personlist_template', true );

	if ( $int_selected_template == 0 ) {
		$int_selected_template = intval( get_option( 'verowa_default_personlist_template' ) );
	}

	$arr_template_in_content = verowa_get_template( $int_selected_template, '', 'content' );

	if ( is_array( $arr_template_in_content ) && count( $arr_template_in_content ) > 0 ) {
		$single_persons = get_post_meta( $post->ID, '_person_singles', true );

		if ( is_array( $single_persons ) && count( $single_persons ) > 0 && !$wp_query->is_search() ) {
			$content .= '[verowa_personen comp_tag="th"]';
		}
	}

	return $content;
}



/**
 * Print the Dropdown to select a template
 * 
 */
function verowa_show_template_dropdown( $str_template_type, $int_selected_template ) {
	$str_return = '';

	$arr_templates = verowa_get_templates_by_type( $str_template_type );

	$str_return .= '<select name="verowa_select_template_' . $str_template_type . '">' . 
		'<option value=""></option>';

	foreach ( $arr_templates as $single_template ) {
		$str_selected = $single_template['template_id'] == $int_selected_template ? 'selected' : '';

		$str_return .= '<option value="' . $single_template['template_id'] . '" ' . $str_selected . '>' . 
			$single_template['template_name'] . '</option>';
	}

	$str_return .= '</select>';

	return $str_return;
}
?>