<?php
/**
 * Generiert das Widget, dass für die Anzeige von zugeordneten Personen benötigt wird.
 * Die Logik der Anzeige wird aber in verowa-show-persons-shortcode.php festgelegt.
 * 
 */

function register_verowa_Persons_widget() {
	register_widget( 'verowa_Persons_Widget' );
}

add_action( 'widgets_init', 'register_verowa_Persons_widget' );

// Widget Klasse
class verowa_Persons_Widget extends WP_Widget {
	function __construct() {
		parent::__construct( 'verowa_Persons_widget', // Base ID
			__( 'Verowa: Show persons', 'verowa-connect' ), // Name
			array(
				'description' => __( 'This widget shows persons from the Verowa database.', 'verowa-connect' ) ,
			) // Args
		);
	}



	public function widget( $args, $instance ) {
		// Widget wird nicht angezeigt, wenn Shortcode verwendet wird oder es keine Person enthält
		global $post, $wpdb;
		
		$int_personlist_template = [];

		$all_persons_function_content = verowa_personen();
		$str_eventlist_shortcode = '';
		$is_empty = strip_tags( $all_persons_function_content );

		$current_post = get_queried_object();
		
		// Get the template id and the template for the Personlist 
		$int_personlist_template = intval( get_post_meta( $post->ID, 'verowa_personlist_template', true ) );

		if ( $int_personlist_template == 0 ) {
			$int_personlist_template = intval( get_option( 'verowa_default_personlist_template' ) );
		}

		$arr_personlist_template = verowa_get_template( $int_personlist_template, '', 'widget' );

		// Wir schauen ob ein template mit "widget" ausgewählt wurde
		if ( ( is_array( $arr_personlist_template ) && count( $arr_personlist_template ) == 0 ) || '' == $is_empty ) {
			$all_persons_function_content = '';
		}

		if ( '' != $all_persons_function_content ) {
			echo $args['before_widget'];

			if ( !empty( $instance['title'] ) ) {
				echo $args['before_title'] . apply_filters( 'widget_title', $instance['title'] ) . $args['after_title'];
			}

			echo $all_persons_function_content;
			echo $args['after_widget'];
		}
	}

	public function form( $instance ) {
		if ( !empty( $instance['title'] ) ) {
			$title = $instance['title'];
		}

		echo '<p><label for="' . $this->get_field_id( 'title' ) . '">' .
			__( 'Title', 'verowa-connect' ) . ':</label>'.
			'<input class="widefat" id="' . $this->get_field_id( 'title' ) . '" ' .
			'name="' . $this->get_field_name( 'title' ) . '" type="text" value="' . esc_attr( $title ) . '"></p>';
	}
	
	public function update( $new_instance, $dummy ) {
		$instance = array();
		
		if ( !empty( $new_instance['title'] ) ) {
			$instance['title'] = strip_tags( $new_instance['title'] );
		} else {
			$instance['title'] = '';
		}
		
		return $instance;
	}
}
?>