<?php
/**
 *	Funktionen, um Personen aus Verowa anzuzeigen.
 *  Hauptsächlich Hilfsfunktionen für die WP-Struktur
 */


// Wenn die Person über den GET-Parameter aufegrufen wird.
// Funktion ist eigentlich Deprecated, weil jetzt Pretty Permalinks vorhanden sind

add_action( 'init', 'retrieve_person_get' );

function retrieve_person_get() {
 	if ( isset( $_GET['person'] ) ) {
		$location = get_bloginfo( 'url' ) . '/person/' . $_GET['person'] . '/';
		wp_redirect( $location, 301 );
		exit;
	}
}


// Um den HTML-Title zu ändern, muss es ein Extra-Aufruf sein, damit es ausserhalb des Loops angewendet werden kann
function verowa_person_html_title( $id ) {
	$arr_person_data = verowa_api_call( 'getpersondetails', $id, true );
	$title = $arr_person_data['firstname'];

	// falls es den Vor- UND den Nachnamen gibt, mit Leerstelle trennen
	if ( '' != $title  && '' != $arr_person_data['lastname'] ) {
		$title .=  ' ';
	}

	$title .= $arr_person_data['lastname'];

	return $title;
}


/**
 * Inhalt der Personen-Seite zusammenstellen
 *
 * @param int $person_id
 * @return string
 */
function show_a_person_from_verowa_detail( $person_id ) {
	$arr_person = verowa_get_person_content_from_db( $person_id );
	$arr_person_data = json_decode( $arr_person['content'], true );
	$str_title = '';
	$arr_placeholders = array();

	$int_persondetails_default_template = get_option( 'verowa_default_persondetails_template', 0 );

	$arr_person_detail_template = verowa_get_template( $int_persondetails_default_template );

	if ( null != $arr_person_data && count( $arr_person_data ) > 0 ) {
		if ( '' != $arr_person_data['detail_image'] ) {
			$arr_placeholders['IMAGE_URL'] = $arr_person_data['detail_image'];
		}

		$str_title = $arr_person_data['firstname'];

		// falls es den Vor- UND den Nachnamen gibt, mit Leerstelle trennen
		if ( '' != $str_title  && '' != $arr_person_data['lastname'] ) {
			$str_title .=  ' ';
		}

		$str_title .= $arr_person_data['lastname'];

		$arr_placeholders['NAME'] = $str_title; /** @deprecated VC 1.6 */
		$arr_placeholders['PERSON_NAME'] = $str_title;

		// Display the profession
		if ( '' != $arr_person_data['profession'] ) {
			$arr_placeholders['PROFESSION'] = $arr_person_data['profession'];
		}

		// Display the short description
		if ( '' != $arr_person_data['short_desc'] ) {
			$arr_placeholders['SHORT_DESC'] = $arr_person_data['short_desc'];
		}

		// Display the tasks
		if ( '' != $arr_person_data['desc_tasks'] ) {
			$arr_placeholders['DESC_TASKS'] = $arr_person_data['desc_tasks'];
		}

		// Display the private address
		if ( '' != $arr_person_data['private_street'] || '' != $arr_person_data['private_postcode'] ||
			'' != $arr_person_data['private_city'] ) {

			$arr_placeholders['HAS_PRIVATE_ADDRESS'] = __( 'Private', 'verowa-connect' ) . ':';

			if ( '' != $arr_person_data['private_street'] ) {
				$arr_placeholders['PRIVATE_STREET'] = $arr_person_data['private_street'];
			}

			if ( '' != $arr_person_data['private_postcode'] || '' != $arr_person_data['private_city']) {
				$str_private_zipcode = '';

				if ( '' != $arr_person_data['private_postcode'] ) {
					$str_private_zipcode = $arr_person_data['private_postcode'] . ' ';
				}

				$arr_placeholders['PRIVATE_ZIP_CITY'] = $str_private_zipcode . $arr_person_data['private_city'];
			}
		}

		// Display the business address
		if ( '' != $arr_person_data['business_street'] || '' != $arr_person_data['business_postcode'] ||
			'' != $arr_person_data['business_city'] ) {

				$arr_placeholders['HAS_BUSINESS_ADDRESS'] = __( 'Business', 'verowa-connect' ) . ':';

			if ( '' != $arr_person_data['business_street'] ) {
				$arr_placeholders['BUSINESS_STREET'] = $arr_person_data['business_street'];
			}

			if ( '' != $arr_person_data['business_postcode'] || '' != $arr_person_data['business_city'] ) {
				$str_business_zipcode = '';

				if ( '' != $arr_person_data['business_postcode'] ) {
					$str_business_zipcode = $arr_person_data['business_postcode'] . ' ';
				}

				$arr_placeholders['BUSINESS_ZIP_CITY'] = $str_business_zipcode . $arr_person_data['business_city'];
			}
		}

		// Display the email
		if ( '' != $arr_person_data['email'] ) {
			$arr_placeholders['EMAIL'] = $arr_person_data['email'];
		}

		// Display the business phone nr.
		if ( '' != $arr_person_data['business_phone'] ) {
			$arr_placeholders['BUSINESS_PHONE'] = $arr_person_data['business_phone'];
		}

		// Display the private phone nr.
		if ( '' != $arr_person_data['private_phone'] ) {
			$arr_placeholders['PRIVATE_PHONE'] = $arr_person_data['private_phone'];
		}

		// Display the mobile phone nr.
		if ( '' != $arr_person_data['mobile_phone'] ) {
			$arr_placeholders['MOBILE_PHONE'] = $arr_person_data['mobile_phone'];
		}

		// Display the personal description
		if ( '' != $arr_person_data['desc_personal'] ) {
			$arr_placeholders['DESC_PERSONAL'] = $arr_person_data['desc_personal'];
		}

		$str_parsed_template = $arr_person_detail_template['header'] .
			verowa_parse_template( $arr_person_detail_template['entry'], $arr_placeholders ) .
			$arr_person_detail_template['footer'];

		return $str_parsed_template;
	}
}
?>