<?php

/**
 *
 * @param array $arr_renting_persons_contact
 * @param array $arr_renting_persons_billing
 *
 * @deprecated Ab Version 2.2.1, neue verowa-formfields-rendering
 * 
 */
function verowa_renting_show_contact_form ($arr_renting_persons_contact, $arr_renting_persons_billing) {
	$str_checked = $_POST['billing_is_different'] == 'on' ? 'checked' : '';

	echo '<h3 style="margin-top: 40; margin-bottom: 10px;">Kontakt und Rechnungsadresse</h3>';

	echo '<div><label for="diffrent_contact"><input type="hidden" name="billing_is_different" value="off"/>' .
		'<input type="checkbox" name="billing_is_different" id="diffrent_contact" value="on" ' . $str_checked .
		' />&nbsp;abweichende Rechnungsadresse</label></div>';

	echo '<div style="display: flex; flex-direction: row; padding: 15px 0px;">';

	if ( count( $arr_renting_persons_contact ) > 0 ) {
		$str_title_style = $str_checked == 'checked' ? '' : 'display: none;';

		echo '<div id="renting-persons" style="width: 50%; padding-right: 7.5px;">';
		echo '<h4 style="' . $str_title_style . '" id="rentin-persons-billing-title">Kontakt</h4>';

		foreach ( $arr_renting_persons_contact as $person_contanct_form_field ) {
			verowa_renting_print_formfields( $person_contanct_form_field, 'arr_renting_persons_contact', $arr_renting_persons_contact, $arr_renting_persons_billing );
		}

		echo '</div>';
	}

	if ( count( $arr_renting_persons_billing ) > 0 ) {
		$str_display_style = $str_checked == 'checked' ? '' : 'display: none;';

		echo '<div id="renting-persons-billing" style="' . $str_display_style . ' width: 50%; padding-left: 7.5px;">';

		echo '<h4>Rechnung</h4>';

		foreach ( $arr_renting_persons_billing as $billing_form_field ) {
			verowa_renting_print_formfields( $billing_form_field, 'arr_renting_persons_billing', $arr_renting_persons_contact, $arr_renting_persons_billing );
		}

		echo '</div>';
	}

	echo '</div>';
}

function verowa_renting_form_validation() {

	$int_form_id = $_POST['form_id'];

	if ( !$_SESSION['errors'] ) {
		$_SESSION['errors'] = [];
	}

	// Standard-Daten aus Verowa Connect
	$verowa_api_key = get_option( 'verowa_api_key', false );
	$verowa_member = get_option( 'verowa_instance', false );
	$verowa_api_url = 'https://api.verowa.ch';
	$int_form_id = $_POST['form_id'];

	// API-URLs vorbereiten
	$str_get_url = $verowa_api_url . '/get_renting_form_fields_hack/' . $verowa_member . '/' . $verowa_api_key .
		'/' . $int_form_id;

	// Load option
	//$ret_option = get_option( 'verowa_subscriptions_settings' );
	//$arr_options = $ret_option != false ? json_decode( $ret_option, true ) : [];

	// Formularfelder holen
	$response = wp_remote_get( $str_get_url );
	$body = json_decode( $response['body'], true );


	$arr_renting_formfields = $body['arr_form_fields'];
	$str_special_display_name = $_POST['billing_is_different'] == 'on' ? 'Kontakt ' : '';

	if ( count( $arr_renting_formfields ) > 0 ) {
		foreach ( $arr_renting_formfields as $renting_form_field ) {
			switch ($renting_form_field['type'])
			{
				case 'contact':
					    foreach ( $renting_form_field['renting_persons_contact'] as $person_contanct_form_field ) {
					        verowa_renting_validate_formfields( $person_contanct_form_field, $_POST['arr_renting_persons_contact'], $int_form_id, $str_special_display_name );
					    }

						if($renting_form_field['options'] != 'no_billing'){
						    foreach ( $renting_form_field['renting_persons_billing'] as $person_contanct_form_field ) {
						        verowa_renting_validate_formfields( $person_contanct_form_field, $_POST['arr_renting_persons_billing'], $int_form_id, $str_special_display_name );
						    }
						}
				    break;

				//case '':
				//    break;

				default:
					verowa_renting_validate_formfields( $renting_form_field, $_POST, $int_form_id );
					break;
			}
		}
	}

	$is_valid = empty( $_SESSION['errors'][$int_form_id] ) ? true : false;
	return $is_valid;
}



function verowa_renting_validate_formfields( $form_field, $arr_post, $int_form_id, $str_display_name = '' ) {
	$str_field_name = key_exists('field_name', $form_field) ?
		$form_field['field_name'] : 'field_' . $form_field['field_id'];

	$str_form_display_name = key_exists('display_name', $form_field) ?
		$form_field['display_name'] : $form_field['label'];

	switch ( $form_field['type'] ) {
		case 'date_with_time':

			$time_from = intval( substr( $arr_post['request_event_period_from'], 0, 2 ) .
				substr( $arr_post['request_event_period_from'], 3, 2 ) );

			$time_to = intval( substr( $arr_post['request_event_period_to'], 0, 2 ) .
				substr( $arr_post['request_event_period_to'], 3, 2 ) );

			$int_time_now = intval( date( 'Hi' ) ) + 100;
			$int_date_today = intval( date( 'Ymd' ) );

			$int_post_date = 0;

			$int_post_date = intval( substr( $arr_post['request_event_date'], 0, 4 ) .
				substr( $arr_post['request_event_date'], 5, 2 ) . substr( $arr_post['request_event_date'], 8, 2 ) );

			if ( $int_post_date != 0 ) {
				if ( $int_post_date == $int_date_today && $time_from < $int_time_now ) {
					$_SESSION['errors'][$int_form_id][] = 'Zeit von: Zeitangabe liegt bereits in der Vergangenheit. Gugus';
				}
			}

			if ( $time_from != 0 || $time_to != 0 ) {
				if ( $time_from < 1600 || $time_to > 500 ) {
					if ( $time_to <= $time_from ) {
						$_SESSION['errors'][$int_form_id][] = 'Zeit bis: Darf nicht vor "Zeit von" liegen.';
					}
				}
			}

			break;
		case 'checkbox':
			$arr_valid_options = ['on', 'off'];

			if ( $form_field['is_required'] == 1 && $arr_post[$str_field_name][0] == 'off' ) {
				if(false !== strpos($form_field['helptext'], '}'))
				{
					$int_index_error_message = $form_field['helptext'][0] == '{' ? 0 : 1;
					$str_error = preg_split( '/[{}]/', $form_field['helptext'],
						-1, PREG_SPLIT_NO_EMPTY)[$int_index_error_message];
				}
				else
				{
					$str_error = trim($str_display_name . $str_form_display_name) . ': Bitte wählen Sie etwas aus.';
				}
			} else if ( in_array( $arr_post[$str_field_name][0], $arr_valid_options ) == false ) {
				$str_error = 'Technischer Fehler in Formular';
			}
			$_SESSION['errors'][$int_form_id][] = $str_error;
			break;
		case 'radio':
			$arr_radio_options = explode( '\r\n' , $form_field['options'] );

			foreach ( $arr_radio_options as $radio_key => $radio_option ) {
				$arr_valid_options[] = explode (';', $radio_option)[0];
			}

			if ( $form_field['is_required'] == 1 && $arr_post[$str_field_name] == '' ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Bitte wählen Sie etwas aus.';

			} else if ( $arr_post[$str_field_name] != ''
				&& in_array( $arr_post[$str_field_name], $arr_valid_options ) == false ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Ungültige Auswahl.';
			}

			break;
		case 'multiple_choice':
			$arr_cb_options = explode( '\r\n', $form_field['options'] );

			if ( $form_field['is_required'] == 1 && empty( $arr_post[$str_field_name] ) ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Bitte wählen Sie etwas aus.';

			} else {
				foreach ( $arr_cb_options as $radio_key => $cb_option ) {
					$arr_valid_options[] = explode (';', $cb_option)[0];
				}

				foreach ( $arr_post[$str_field_name] as $cb_option ) {
					if ( in_array( $cb_option, $arr_valid_options ) == false ) {
						$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Ungültige Auswahl (' . $cb_option . ').';
					}
				}
			}

			break;

		case 'dropdown':
			$arr_dd_options = explode( PHP_EOL, $form_field['options'] );

			foreach ( $arr_dd_options as $dd_key => $dd_option ) {
				$arr_value_name = preg_split( '/[{}]/', $dd_option, -1, PREG_SPLIT_NO_EMPTY );

				$arr_valid_options[] = $arr_value_name[0];
			}
			if ( $form_field['is_required'] == 1 && $arr_post[$str_field_name] == '' ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
					': Bitte wählen Sie etwas aus.';

			} else if ( $arr_post[$str_field_name] != ''
				&& in_array( $arr_post[$str_field_name], $arr_valid_options ) == false ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
					': Ungültige Auswahl.';
			}

			break;

		case 'time':
			$str_field_name = 'field_' . $form_field['field_id'];
			$int_time = intval( substr( $arr_post[$str_field_name], 0, 2 ) .
				substr( $arr_post[$form_field[$str_field_name]], 3, 2 ) );

			$time_from = 0;
			$time_to = 0;

			if ( $form_field['is_required'] == 1 && $arr_post[$form_field[$str_field_name]] == '' ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Darf nicht leer sein.';

			} else if ( count( $arr_post[$form_field[$str_field_name]] ) <= 5 ) {
				if ( preg_match( '/^\d{2}(:)\d{2}$/', $arr_post[$form_field[$str_field_name]] ) == 1 ) {
					if ( $arr_post[$form_field[$str_field_name]] != '' && $int_time > 2359 ) {
						$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Ungültige Zeitangabe.';

					} else if ( $arr_post[$form_field[$str_field_name]] != '' && $int_time < 0 ) {
						$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Ungültige Zeitangabe.';
					}

				} else {
					$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Ungültiges Format. Beispiel: 16:30';
				}
			} else {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Ungültiges Format. Beispiel: 16:30';
			}

			break;
		case 'textarea':
			$arr_min_max = json_decode( $form_field['custom_fields'], true );

			if ( $form_field['is_required'] == 1 && $arr_post[$str_field_name] == '' ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
					': Darf nicht leer sein.';

			} else if ( strlen( $arr_post[$str_field_name] ) > $arr_min_max['max_chars'] ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
					': Darf nicht mehr als ' .
				$arr_min_max['max_chars'] . ' Zeichen lang sein (derzeit: ' . strlen( $arr_post[$str_field_name] ) . ').';
			} else if ( strlen( $arr_post[$str_field_name] ) < $arr_min_max['min_chars'] ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
					': Darf nicht weniger als ' .
					$arr_min_max['min_chars'] . ' Zeichen lang sein (derzeit: ' . strlen( $arr_post[$str_field_name] ) . ').';
			}

			break;
		case 'text':
			$int_max_chars = intval($form_field['options']) > 0 ? intval($form_field['options']) : 80;
			$arr_min_max = [
				'min_chars' => null,
				'max_chars' => $int_max_chars
				];

			if ( $form_field['is_required'] == 1 && $arr_post[$str_field_name] == '' ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
					': Darf nicht leer sein.';

			} else if ( strlen( $arr_post[$str_field_name] ) > $arr_min_max['max_chars'] ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
					': Darf nicht mehr als ' .
					$arr_min_max['max_chars'] . ' Zeichen lang sein (derzeit: ' . strlen( $arr_post[$str_field_name] ) . ').';

			} else if ( strlen( $arr_post[$str_field_name] ) < $arr_min_max['min_chars'] ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
					': Darf nicht weniger als ' .
					$arr_min_max['min_chars'] . ' Zeichen lang sein (derzeit: ' . strlen( $arr_post[$str_field_name] ) . ').';
			}

			break;
		case 'email':
			$int_max = intval($form_field['options']) > 0 ? intval($form_field['options']) : 80;

			if ( $form_field['is_required'] == 1 && $arr_post[$str_field_name] == '' ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Darf nicht leer sein.';

			} else if ( strlen( $arr_post[$str_field_name] ) > $int_max ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Darf nicht mehr als ' .
					$int_max . ' Zeichen lang sein (derzeit: ' . strlen( $arr_post[$str_field_name] ) . ').';
			} else if ( $arr_post[$str_field_name] != '' && is_email( $arr_post[$str_field_name] ) == false ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Ungültige E-Mail-Adresse.';
			}

			break;
		case 'number':
			$arr_formfield_options = explode( ';', $this->str_options );

			$int_min = $arr_formfield_options[0];
			$int_max = $arr_formfield_options[1];
			$arr_min_max = [
				'min_chars' => $int_min,
				'max_chars' => $int_max
			];

			if ( $form_field['is_required'] == 1 && $arr_post[$str_field_name] <= 0 ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name)
					. ': Darf nicht leer sein.';

			} else if ( $arr_post[$str_field_name] ) {
				if ( $arr_post[$str_field_name] > $arr_min_max['max_chars'] ) {
					$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Darf nicht grösser als ' .
						$arr_min_max['max_chars'] . ' sein (derzeit: ' . $arr_post[$str_field_name] . ').';

				} else if ( $arr_post[$str_field_name] < $arr_min_max['min_chars'] ) {
					$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Darf nicht kleiner als ' .
						$arr_min_max['max_chars'] . ' sein (derzeit: ' . $arr_post[$str_field_name] . ').';

				} else if ( false == is_numeric( $arr_post[$str_field_name] ) ) {
					$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Bitte geben Sie eine Zahl ein.';
				}
			}

			break;
		case 'date':
			$str_date_today = date( 'Ymd' );

			$int_post_date = intval( substr( $arr_post[$str_field_name], 0, 4 ) .
					substr( $arr_post[$str_field_name], 5, 2 ) . substr( $arr_post[$str_field_name], 8, 2 ) );

			if ( $form_field['is_required'] == 1 && $arr_post[$str_field_name] <= 0 ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) . ': Darf nicht leer sein.';

			} else if ( count( $arr_post[$str_field_name] ) <= 10 ) {
				if ( preg_match( '/^\d{4}(-)\d{2}(-)\d{2}$/', $arr_post[$str_field_name] ) == 1 ) {
					if ( $int_post_date != '' && $int_post_date < intval( $str_date_today ) ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
					': Darf nicht in der Vergangenheit liegen.';
			}
				} else {
					$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
						': Ungültiges Format. Beispiel: 2021-02-19';
				}
			} else {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
					': Ungültiges Format. Beispiel: 2021-02-19';
			}

			break;
		case 'datetime':
			$str_date_today = date( 'Ymd' );

			$int_post_date = intval( substr( $arr_post[$str_field_name . '_date'], 0, 4 ) .
					substr( $arr_post[$str_field_name . '_date'], 5, 2 ) . substr( $arr_post[$str_field_name . '_date'], 8, 2 ) );
			$int_post_time_von = intval( substr( $arr_post[$str_field_name . '_von'], 0, 2 ) .
				substr( $arr_post[$str_field_name . '_von'], 3, 2 ) );
			$int_post_time_bis = intval( substr( $arr_post[$str_field_name . '_bis'], 0, 2 ) .
				substr( $arr_post[$str_field_name . '_bis'], 3, 2 ) );

			if ( $form_field['is_required'] == 1 && $arr_post[$str_field_name] <= '' ) {
				$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name)
					. ': Darf nicht leer sein.';

			} else if ( $arr_post[$str_field_name] != '' ) {
				if ( $int_post_date < intval( $str_date_today ) ) {
					$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
						': Darf nicht in der Vergangenheit liegen.';
				} else if ( $int_post_time_von > 2359 || $int_post_time_bis > 2359 ) {
					$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
						': Ungültige Zeitangabe.';

				} else if ( $int_post_time_von < 0 || $int_post_time_bis < 0 ) {
					$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
						': Ungültige Zeitangabe.';

				} else if ( $int_post_time_von >= $int_post_time_bis) {
					$_SESSION['errors'][$int_form_id][] = trim($str_display_name . $str_form_display_name) .
						': "von"-Zeit Darf nicht nach "bis"-Zeit sein.';
				}
			}

			break;
		case 'hidden':
			$arr_valid_option = preg_split( '/[{}]/', $form_field['default_value'], -1, PREG_SPLIT_NO_EMPTY );

			if ( $form_field['is_required'] == 1 && $arr_post[$str_field_name] <= '' ) {
				$_SESSION['errors'][$int_form_id][] = 'Technischer Fehler in Formular';
			} else if ( $arr_post[$str_field_name] != '' && $arr_post[$str_field_name] != $arr_valid_option[0] ) {
				$_SESSION['errors'][$int_form_id][] = 'Technischer Fehler in Formular';
			}

			break;
	}
}