<?php
use Ppg\Verowa_Connect\Verowa_Formfields_Rendering;

add_shortcode( 'verowa_renting_form', 'verowa_room_renting_form' );


function verowa_room_renting_form( $atts ) {
	$atts = shortcode_atts( array(
		'form_id' => 0,
	) , $atts, 'verowa_renting_form' );

	// Standard-Daten aus Verowa Connect
	$verowa_api_key = get_option( 'verowa_api_key', false );
	$verowa_member = get_option( 'verowa_instance', false );
	$verowa_api_url = 'https://api.verowa.ch';
	$int_form_id = $atts['form_id'];

	// API-URLs vorbereiten
	$str_get_url = $verowa_api_url . '/get_renting_form_fields_hack/' . $verowa_member . '/' . $verowa_api_key . '/' . $int_form_id;


	// Formularfelder holen
	$response = wp_remote_get( $str_get_url );
	$body = json_decode( $response['body'], true );

	$arr_renting_formfields = $body['arr_form_fields'];


	$arr_errors = $body['arr_error'];

	ob_start();
	echo '<div class="vc_renting_form_error_wrapper">';
	if ( isset( $_SESSION['errors'][$int_form_id] ) ) {
		foreach ( $_SESSION['errors'][$int_form_id] as $str_single_error ) {
			echo '<p style="color: red;">' . $str_single_error . '</p>';
		}
	}
	echo '</div>';

	if ( $body['http_status'] == 200 ) {
		echo '<div>';
		echo '<form action="" method="POST">';
		echo '<input type="hidden" name="form_id" value="' . $int_form_id . '" />';

		if ( count( $arr_renting_formfields ) > 0 ) {
			echo '<div class="renting-formfields" style="padding: 15px 0px;">';

			foreach ( $arr_renting_formfields as $renting_form_field ) {
				$obj_formfields = new Verowa_Formfields_Rendering($renting_form_field);
				$obj_formfields->print_input_control();
			}

			echo '</div>';
		}
	}

	echo '<div class="vc_renting_form_submit" ><i>Felder mit einem Stern (*) sind Pflichtfelder.</i>';
	echo '<input style="padding: 10px 0px;" type="submit" name="renting_form_submit" value="senden" /></div>';

	echo '</form>';
	echo '</div>';

	return ob_get_clean ();
}

