<?php

add_action( 'parse_request', 'verowa_renting_request_handler', 40, 0 );
add_action( 'verowa_renting_submit', 'verowa_renting_submit' );
add_action( 'wp_footer', 'verowa_renting_flush_error' );


function verowa_renting_flush_error() {
    if (key_exists('errors', $_SESSION) && $_SESSION['errors'] ) {
		$_SESSION['errors'] = array();
    }
}

function verowa_renting_request_handler() {
	if ( key_exists('renting_form_submit', $_POST) && $_POST['renting_form_submit'] == 'senden' ) {
		$is_valid = verowa_renting_form_validation();

		if ( $is_valid ) {
			do_action( 'verowa_renting_submit' );
			header( 'Location: https://' . $_SERVER['HTTP_HOST'] . '/reservationsanfrage-response/' );
			echo '<script type="text/javascript"> window.location.href = ' .
			'"https://' . $_SERVER['HTTP_HOST'] . '/reservationsanfrage-response/"; </script>' ;
		}
	}
}

function verowa_renting_submit() {

	// Standard-Daten aus Verowa Connect
	$verowa_api_key = get_option( 'verowa_api_key', false );
	$verowa_member = get_option( 'verowa_instance', false );
	$verowa_api_url = 'https://api.verowa.ch';
	$send_form_method = 'save_renting_request';

	// API-URLs vorbereiten
    $str_send_url = $verowa_api_url . '/' . $send_form_method;

    $arr_renting_data = array();

    foreach ( $_POST as $post_key => $post ) {
		if ( true == is_array( $post ) ) {
			foreach ( $post as $post_arr_key => $post_value ) {
				if ( true == is_array( $post_value ) ) {
					foreach ( $post_value as $post_inner_key => $post_inner_value ) {
						$arr_renting_data[$post_key][$post_arr_key][$post_inner_key] = trim( $post_inner_value );
					}
				} else {
					$arr_renting_data[$post_key][$post_arr_key] = trim( $post_value );
				}
			}
		} else {
			$arr_renting_data[$post_key] = trim( $post );
		}
    }

	// Requests from plugin version 2.2.1 must be interpreted, as only IDs are sent by Verowa.
	$arr_renting_data['form_data_need_interpretation'] = true;

    $response = wp_remote_post(
		$str_send_url,
		array(
			'method' => 'POST',
			'timeout' => 45,
			'redirection' => 5,
			'httpversion' => '1.0',
			'blocking' => true,
			'headers' => array( 'member' => $verowa_member, 'apikey' => $verowa_api_key ),
			'body' => json_encode( $arr_renting_data, true ),
			'cookies' => array()
		)
	);

	$body = json_decode( $response['body'], true );

 	$_SESSION['message'] = $body['message'];
	$_SESSION['request_saved'] = $body['request_saved'];
}