<?php
add_shortcode('verowa_renting_validate', 'verowa_renting_validate');

function verowa_renting_validate() {

	ob_start ();

	$verowa_api_key = get_option( 'verowa_api_key', false );
	$verowa_member = get_option( 'verowa_instance', false );

	// Erst wird geprüft, ob die Option gefunden wurde und dann, ob ein Wert eingetragen wurde.
	if( $verowa_api_key != false && strlen( $verowa_api_key ) > 0 && 
		$verowa_member != false && strlen( $verowa_member ) > 0 )
    {
        // Standard-Daten aus Verowa Connect
        $verowa_api_url = 'https://api.verowa.ch';
        $send_form_method = 'validate_renting_request';

        $str_send_url = $verowa_api_url . '/' . $send_form_method;
        
        if ( $_GET['rk'] && $_GET['ri'] )
        {	
			$request_id = isset( $_GET['ri'] ) ? intval( $_GET['ri'] ) : 0;
			$request_key = isset( $_GET['rk'] ) ? sanitize_text_field( $_GET['rk'] ) : '';

            $validate_response = wp_remote_post( $str_send_url, array(
                'method' => 'POST',
                'timeout' => 45,
                'redirection' => 5,
                'httpversion' => '1.0',
                'blocking' => true,
                'headers' => array( 'member' => $verowa_member, 'apikey' => $verowa_api_key ),
                'body' => json_encode( array ( 'request_id' => $request_id, 'request_key' => $request_key ), true ),
                'cookies' => array()
            ));

            $validate_body = json_decode( $validate_response['body'], true );
       
            // Check the validate_response code
            $validate_response_code = wp_remote_retrieve_response_code( $validate_response );
            $validate_response_message = wp_remote_retrieve_response_message( $validate_response );
            
			echo $validate_body['message'];

		}
	}
    return ob_get_clean ();
}