<?php
/*
	Ergänzt zwei Shortcodes:
	- verowa_roster_entries
	- verowa-first-roster-entry
*/


add_shortcode( 'verowa_roster_entries', 'verowa_roster_entries' );
 
function verowa_roster_entries( $atts ) {
	$id = $atts['id'];
	ob_start();
	$roster_array = verowa_api_call( 'getrosterentries', $id, true);
	
	echo '<h3 class="verowa-roster-headline">' .
		__( 'Service weeks', 'verowa-connect' ) . ' '. date( 'Y' ).'</h3>';
	echo '<div class="verowa-roster-entries">';	

	foreach ( $roster_array as $single_roster ) {
		$time = strtotime( $single_roster['datetime_from'] );
		echo '<div class="roster-entry">';

		/* tranlators: CW = abbrev. calendar week */
		echo '<span class="roster-date">' . __( 'CW', 'verowa-connect' ) . ' ' . date_i18n( 'W', $time ) .
			': ' . _x( 'from', 'temporal', 'verowa-connect' ) . ' ' . date_i18n( 'j. M. Y', $time ) . '</span>';
		echo '<span class="roster-person">' . $single_roster['content'][0]['text'] . '</span>' . PHP_EOL;
		echo '<span class="add-roster-data">';

		if ( '' != $single_roster['content'][0]['email'] || '' != $single_roster['content'][0]['phone'] ) {
			echo '(';
		
			if ( '' != $single_roster['content'][0]['email'] ) {
				echo verowa_email_obfuscate( $single_roster['content'][0]['email'] );

				// wenn es beide Angaben gibt, trennen wir sie von einander ab
				if ( '' != $single_roster['content'][0]['phone'] ) echo ', ';
			}
	
			if ( '' != $single_roster['content'][0]['phone'] ) {
				echo __( 'phone', 'verowa-connect' ) . ': ' . $single_roster['content'][0]['phone'];
			}

			echo ')';
		}

		echo '</span>';
		echo '</div>' . PHP_EOL;
	}

	echo '</div>';	

	return ob_get_clean();
}



add_shortcode( 'verowa-first-roster-entry','verowa_first_roster_entry' );

function verowa_first_roster_entry( $atts ) {
	$id = $atts['id'];
	ob_start();
	$roster_array = verowa_api_call( 'getrosterentries', $id, true );

	if ( count( $roster_array ) > 0 ) {
		$single_roster = $roster_array[0]['content'][0];

		// wird benötigt, um den URL des Bildes abzufragen
		$arr_einzelne_person = verowa_api_call( 'getpersonsbyid', $single_roster['id'], true);
		echo '<h2 class="verowa-roster-headline">' . __( 'Current service week', 'verowa-connect' ) . '</h2>';
		echo '<div class="verowa-single-roster-entry">';

		if ( count( $arr_einzelne_person ) > 0 ) {
            echo '<div><img width="145" height="145" src="' . $arr_einzelne_person[0]['image_url'] . '" ' .
            	'title="' . $single_roster['text'] . '" /></div>' . PHP_EOL;
        }

		echo '<div class="single-roster-entry">';
		echo '<span class="roster-person">' . $single_roster['text'] . '</span>';
		echo '<span class="add-roster-data">';

		if ( '' != $single_roster['phone'] ) {
			echo $single_roster['phone'] . '<br />' . PHP_EOL;
		}

		if ( '' != $single_roster['email'] ) {
			echo verowa_email_obfuscate( $single_roster['email'] );
		}

		echo '</span></div></div>';
	}

	echo '</div>';

	return ob_get_clean();
}



function verowa_email_obfuscate( $str_email ) {
	$email_parts = explode( '@', $str_email );

	return '<span class="email"><script>var affenschwanz="@"; document.write("' .
		'<a href=\"mailto:' . $email_parts[0] . '"+affenschwanz+"' . $email_parts[1].'\">' .
		__( 'e-mail', 'verowa-connect' ) . '</a>");</script></span>';
}
?>