<?php
	
/*
 *	Description: Admin-Page zum Eintragen von Projekten, URLs und Key Codes zum Monitoring
*/

add_action ('admin_menu', 'subscriptions_admin_page');

//Admin-Page im Admin Bereich anzeigen
function subscriptions_admin_page() {
	add_options_page(
		'Verowa Anmeldungen',
		'Verowa Anmeldungen',
		'manage_options',
		'subscriptions_settings',
		'render_subscriptions_options_page'
	);
}


//Anzeige in der Admin-Page
function render_subscriptions_options_page() {
	?>
		<form action="options-general.php?page=subscriptions_settings" method="post">
			<h1>Verowa-Anmeldungen</h1>
			<?php 
				if ( key_exists( 'btnSave', $_POST ) ) {
					$arr_options = $_POST;
					$ret_add = add_option( 'verowa_subscriptions_settings', json_encode($_POST) );

					if ( !$ret_add ) {
						update_option('verowa_subscriptions_settings', json_encode($_POST));
					}
				} else {
					$ret_option = get_option('verowa_subscriptions_settings');
					$arr_options = $ret_option != false ? json_decode($ret_option, true) : [];
				}
			?>

		
			<input type="hidden" value="off" name="display_street" />
			<input type="hidden" value="off" name="required_street" />
			<input type="hidden" value="off" name="display_city" />
			<input type="hidden" value="off" name="required_city" />
			<input type="hidden" value="off" name="only_today" />
			<input type="hidden" value="off" name="hide_bookable_seats" />
			<input type="hidden" value="off" name="hide_free_seats" />
			<input type="hidden" value="off" name="hide_numbers_when_infinite" />
			<input type="hidden" value="off" name="show_event_link" />

			<table cellpadding = "3" cellspacing = "0">
				<tr>
					<th>&nbsp;</th>
					<th>Anzeigen</th>
					<th>Pflichtfelder</th>
				</tr>
				<tr>
					<td style="border-bottom: 1px solid; width: 150px;">Strasse, Nr.</td>
					<td style="border-bottom: 1px solid; width: 150px;text-align: center;">
						<label style="width: 100%; display:block;">
							<input type="checkbox" name="display_street" <?= pp_set_cb_checked('display_street', $arr_options) ?> />
						</label>
					</td>
					<td style="border-bottom: 1px solid; width: 150px;text-align: center;" ><label style="width: 100%; display:block;" >
					<input type="checkbox" name="required_street" 
					<?= pp_set_cb_checked('required_street', $arr_options) ?> /><label></td>
				<tr>
				<tr>
					<td>PLZ, Ort</td>
					<td style="text-align: center;" >
					<label style="width: 100%; display:block;">
					<input type="checkbox" name="display_city"
					<?= pp_set_cb_checked('display_city', $arr_options) ?> /></label></td>
					<td style="text-align: center;" >
					<label style="width: 100%; display:block;">
					<input type="checkbox" name="required_city" 
					<?= pp_set_cb_checked('required_city', $arr_options) ?> /></label></td>
				<tr>
			</table>
			<hr />
			<table cellpadding = "3" cellspacing = "0">
				<tr>
					<td>reCAPTCHA Public Key</td>
					<td>
						<input type="text" name="recaptcha_key_public" 
							value="<?= $arr_options['recaptcha_key_public'] ?>" size="50" />
					</td>
				</tr>
				<tr>
					<td>reCAPTCHA Secret Key</td>
					<td>
					<input type="text" name="recaptcha_key_secret" 
					value="<?= $arr_options['recaptcha_key_secret'] ?>" size="50" />
					</td>
				</tr>
				<tr>
					<td>
						<input type="checkbox" name="only_today" <?php echo pp_set_cb_checked('only_today', $arr_options); ?> />Nur Veranstaltungen des aktuellen Tags zeigen
					</td>
				</tr>
				<tr>
					<td>
						<input type="checkbox" name="hide_free_seats" <?php echo pp_set_cb_checked('hide_free_seats', $arr_options); ?> />Anzahl freie Plätze verbergen
					</td>
				</tr>
				<tr>
					<td>
						<input type="checkbox" name="hide_bookable_seats" <?php echo pp_set_cb_checked('hide_bookable_seats', $arr_options); ?> />Anzahl reservierbare Plätze verbergen
					</td>
				</tr>
				<tr>
					<td>
						<input type="checkbox" name="hide_numbers_when_infinite" <?php echo pp_set_cb_checked('hide_numbers_when_infinite', $arr_options); ?> />Anzahl Plätze verbergen, wenn unbegrenzt
					</td>
				</tr>
				<tr>
					<td>
						<input type="checkbox" name="show_event_link" <?php echo pp_set_cb_checked('show_event_link', $arr_options); ?> />Detaillinks im Formular anzeigen
					</td>
				</tr>
				<tr>
					<td>
					max. Plätze pro Anmeldung
					</td>
					<td> 
						<select name="max_seats">
						<?php
							for ( $i = 1; $i <= 6; $i++ ) {
								$selected_max_seats = pp_set_dd_selected ('max_seats', $arr_options, $i);

								echo '<option value="' . $i . '" ' . $selected_max_seats . '>' . $i . '</option>';
							} 
						?>
						</select>
					</td>
				</tr>
				<tr>
				<td>
					<h3>Validierungsseite</h3>
				</td>
				</tr>
				<tr>
					<td style="vertical-align: top;">
					Detaillink
					</td>
					<td>
						<input type="text" name="event_detail_link" value="<?= $arr_options['event_detail_link'] ?>" size="50" /></br>
						<p>Beispiel: https://www.meinegemeinde.ch/veranstaltung/{%event_id%}/</p> 
					</td>
				</tr>			
				<tr>
					<td style="text-align: right;" colspan="2" >
						<button class="button button-primary mt-2" style="margin: 10px 10px 0 0;" name="btnSave" >speichern</button>
					</td>
				</tr>
			</table>
		</form>
	<?php
}



function pp_set_dd_selected( $field_name, $arr_options, $value ) {
	$ret = '';

	if ( key_exists ($field_name, $arr_options) && intval ( $arr_options[$field_name] ) == $value ) {
		$ret = 'selected';
	}

	return $ret;
}



function pp_set_cb_checked( $fild_name, $arr_options ) {
	$ret = '';

	if ( key_exists( $fild_name, $arr_options ) && 'on' == $arr_options[$fild_name]) {
		$ret = 'checked';
	}

	return $ret;
}