<?php
add_action ( 'parse_request', 'verowa_subscriptions_request_handler', 30, 0 );
add_action ( 'ct_submit', 'verowa_subscriptions_submit' );
add_action ( 'wp_footer', 'verowa_subscriptions_flush_error' );

function verowa_subscriptions_flush_error () {
    if ( key_exists('error', $_SESSION) && $_SESSION['error'] ) {
        $_SESSION['error'] = array();
    }
}



function verowa_subscriptions_request_handler () {
    if ( isset( $_POST['send_infos'] ) && wp_verify_nonce( $_POST['send_infos'], 'send_infos' ) ) {

        $is_valid = verowa_subscriptions_form_validation ();

        if ( $is_valid ) {
            do_action ( 'ct_submit' );
			//header( 'Location: https://' . $_SERVER['HTTP_HOST'] . '/contact-tracing-response/' );
			echo '<script type="text/javascript"> window.location.href = ' . 
			'"https://' . $_SERVER['HTTP_HOST'] . '/contact-tracing-response/"; </script>' ;
        }
    }
}



function verowa_subscriptions_submit () {
    // Standard-Daten aus Verowa Connect
	$verowa_api_key = get_option( 'verowa_api_key', false );
	$verowa_member = get_option( 'verowa_instance', false );
	$verowa_api_url = 'https://api.verowa.ch';
	$send_form_method = 'subscribetoevent';
    $int_seats_count = 0;

	// API-URLs vorbereiten
    $str_send_url = $verowa_api_url . '/' . $send_form_method;
    
    $arr_tracing_data = array();        
    
    foreach ( $_POST as $key => $value ) {

        // Wenn es mehrere seats Felder hat rechnen wir Sie zusammen
        if ( false !== strpos( $key, 'nb_seats_' ) ) {
            $int_seats_count += trim( $value );
        }
        
        $arr_tracing_data[$key] = is_array( $value ) === true ? $value : trim( $value );
    }

    if ( $int_seats_count > 0 ) {
    	$arr_tracing_data['nb_seats'] = $int_seats_count ;
    }    

    $response = wp_remote_post(
        $str_send_url,
        array(
	        'method' => 'POST',
	        'timeout' => 45,
	        'redirection' => 5,
	        'httpversion' => '1.0',
	        'blocking' => true,
	        'headers' => array( 'member' => $verowa_member, 'apikey' => $verowa_api_key ),
	        'body' => json_encode( $arr_tracing_data, true ),
	        'cookies' => array()
        )
    );

    $body = json_decode( $response['body'], true );

    // Check the response code
    $response_code = wp_remote_retrieve_response_code( $response );
    $response_message = wp_remote_retrieve_response_message( $response );
    
    if ( 200 != $response_code ) {
        if (! empty( $response_message ) ) {
			$_SESSION['response'] = $response_message;
        } else {
			$_SESSION['response'] = __('An unhandled error occurred.', 'verowa-subscriptions');
        }
    } else {
		$_SESSION['response'] = $body['message'];
		$_SESSION['subs_state'] = $body['subs_state'];
        $_SESSION['custom_formfields'] = $body['custom_formfields'];
        $_SESSION['subs_data'] = $body['subs_data'];
        $_SESSION['back_to_form'] = $body['back_to_form'];
    }     
}
?>