<?php

add_shortcode ( 'verowa_subscriptions_validation_anmeldung', 'verowa_subscriptions_validation' );

function verowa_subscriptions_validation () {  
    ob_start ();

	$verowa_api_key = get_option( 'verowa_api_key', false );
	$verowa_member = get_option( 'verowa_instance', false );

	// Erst wird geprüft, ob die Option gefunden wurde und dann, ob ein Wert eingetragen wurde.
	if( $verowa_api_key != false && strlen($verowa_api_key) > 0 && 
		$verowa_member != false && strlen( $verowa_member ) > 0 ) {
        
        // Standard-Daten aus Verowa Connect
        $verowa_api_url = 'https://api.verowa.ch';
        $send_form_method = 'validate_event_subscription';
        $get_event_detail = 'geteventdetails';

        $str_send_url = $verowa_api_url . '/' . $send_form_method;

        // Load option
        $ret_option = get_option( 'verowa_subscriptions_settings' );
        $arr_options = $ret_option != false ? json_decode( $ret_option, true ) : [];        
        
        if ( $_GET['k'] && $_GET['si'] ) {
            $subs_key = sanitize_text_field ( $_GET['k'] );
            $subs_id = sanitize_text_field ( $_GET['si'] );

            $validate_response = wp_remote_post(
                $str_send_url,
                array(
	                'method' => 'POST',
	                'timeout' => 45,
	                'redirection' => 5,
	                'httpversion' => '1.0',
	                'blocking' => true,
                    'headers' => array(
                        'member' => $verowa_member,
                        'apikey' => $verowa_api_key
                    ),
                    'body' => json_encode(
                        array(
                            'subs_key' => $subs_key,
                            'subs_id' => $subs_id
                        ),
                        true
                    ),
	                'cookies' => array()
                )
            );

            $validate_body = json_decode( $validate_response['body'], true );
       
            // Check the validate_response code
            $validate_response_code = wp_remote_retrieve_response_code( $validate_response );
            $validate_response_message = wp_remote_retrieve_response_message( $validate_response );
            
            if ( 200 != $validate_response_code ) {
                if (! empty( $validate_response_message ) ) {
                    echo $validate_response_message;
                } else {
                    echo __('An unhandled error occurred.', 'verowa-subscriptions');
                }
            } else {
                echo $validate_body['message'] . '</br>';
            }
            
            
            //GET EVENT DETAILS
            $str_get_url = $verowa_api_url . '/' . $get_event_detail . '/' . $verowa_member . '/' . $verowa_api_key . 
                '/' . $validate_body['event_id'];

            $event_detail_response = wp_remote_get( $str_get_url );
			$event_detail_body = json_decode( $event_detail_response['body'], true );

            // Check the response code
			$response_code = wp_remote_retrieve_response_code( $event_detail_response );
			$response_message = wp_remote_retrieve_response_message( $event_detail_response );
			
            if ( 200 != $response_code ) {
                if (! empty( $response_message ) ) {
					echo $response_message;
                } else {
					echo __('An unhandled error occurred.', 'verowa-subscriptions');
				}
			} else if ( isset( $event_detail_body['message'] ) ) {
				echo $event_detail_body['message'];
            } else {
                $str_event_link = str_replace ( '{%event_id%}', $event_detail_body[0]['event_id'], $arr_options['event_detail_link'] );

                echo '</br><p class="verowa-subs_validate-message">' . 
                    __( 'You have selected the following event', 'verowa-subscriptions' ) . ':</br>' . 
                    $event_detail_body[0]['title'] . ', ' . $event_detail_body[0]['date_text'] . '</p>' . 
                    '<a href="' . $str_event_link . '">' . __( 'Details', 'verowa-subscriptions' ) . '</a>';
            }

        }
    } else {
		echo '<b>' . __('The plugin Verowa-Connect has not yet been installed or the API not yet configured.', 
			'verowa-subscriptions') . '</b>';
    }

    return ob_get_clean ();
}
?>